C **********************************************************************
C  WOLFRAM RUEHAAK, 2006
C  Necessary for the CENTRAL DIFFERENCING SCHEME FOLLOWING PERIC, 1985, 
C  S. 76
C
C  A) Initialize values (head & temperature) at the borders before the 
C     first time-step; necessary to calculate the ghost-node values 
C     (at index 0 and I0+1 ...).
C  B) set ghost-node values (head & temperature)
C
C **********************************************************************
      SUBROUTINE BORDERPHI()
      
      USE FELDER      
      USE NO
      
      IMPLICIT NONE      
      
      include 'genrl.inc'
      include 'genrlc.inc'
      INTEGER IP2,JP2,KP2
      IF(LINFO.GE.2) WRITE(*,*)'BORDERPHI working'
C ######################################################################
C NICHT INITIALISIERTE WERTE VORBELEGEN BY ERSTEM AUFRUF
      IF(MYCOUNTER.EQ.0)THEN
      WRITE(*,*) 'MYCOUNTER = ', MYCOUNTER
      DO K = 1,K0
         DO J = 1,J0
            DO I = 1,I0
                  IF(I.EQ.1)THEN
                  p_w(I,J,K) = phi(I,J,K)
                  TEMP_w(I,J,K) = TEMP(I,J,K)
                  ENDIF
                  IF(I.EQ.I0)THEN
                  p_e(I,J,K) = phi(I,J,K)
                  TEMP_e(I,J,K) = TEMP(I,J,K)
                  ENDIF
                  IF(J.EQ.1)THEN
                  p_s(I,J,K) = phi(I,J,K)
                  TEMP_s(I,J,K) = TEMP(I,J,K)
                  ENDIF
                  IF(J.EQ.J0)THEN
                  p_n(I,J,K) = phi(I,J,K)
                  TEMP_n(I,J,K) = TEMP(I,J,K)
                  ENDIF
                  IF(K.EQ.1)THEN
                  p_b(I,J,K) = phi(I,J,K)
                  TEMP_b(I,J,K) = TEMP(I,J,K)
                  ENDIF
                  IF(K.EQ.K0)THEN
                  p_t(I,J,K) = phi(I,J,K)
                  TEMP_t(I,J,K) = TEMP(I,J,K)
                  ENDIF
            ENDDO
         ENDDO
      ENDDO
      ENDIF
      MYCOUNTER = MYCOUNTER+1

      DO K = 1,K0
         DO J = 1,J0
            DO I = 1,I0

               phi0(I,J,K)=phi(I,J,K)
               TP0(I,J,K) =TEMP(I,J,K)

                  IF(I.EQ.1)THEN
                  IP2 = I-1
                  JP2 = J
                  KP2 = K
                  phi0(IP2,JP2,KP2)=p_w(I,J,K)
                  TP0(IP2,JP2,KP2)=TEMP_w(I,J,K)
                  ENDIF
                  IF(I.EQ.I0)THEN
                  IP2 = I+1
                  JP2 = J
                  KP2 = K
                  phi0(IP2,JP2,KP2)=p_e(I,J,K)
                  TP0(IP2,JP2,KP2)=TEMP_e(I,J,K)
                  ENDIF
                  IF(J.EQ.1)THEN
                  IP2 = I
                  JP2 = J-1
                  KP2 = K
                  phi0(IP2,JP2,KP2)=p_s(I,J,K)
                  TP0(IP2,JP2,KP2)=TEMP_s(I,J,K)
                  ENDIF
                  IF(J.EQ.J0)THEN
                  IP2 = I
                  JP2 = J+1
                  KP2 = K
                  phi0(IP2,JP2,KP2)=p_n(I,J,K)
                  TP0(IP2,JP2,KP2)=TEMP_n(I,J,K)
                  ENDIF
                  IF(K.EQ.1)THEN
                  IP2 = I
                  JP2 = J
                  KP2 = K-1
                  phi0(IP2,JP2,KP2)=p_b(I,J,K)
                  TP0(IP2,JP2,KP2)=TEMP_b(I,J,K)
                  ENDIF
                  IF(K.EQ.K0)THEN
                  IP2 = I
                  JP2 = J
                  KP2 = K+1         
                  phi0(IP2,JP2,KP2)=p_t(I,J,K)
                  TP0(IP2,JP2,KP2)=TEMP_t(I,J,K)
                  ENDIF
            ENDDO
         ENDDO
      ENDDO
C ######################################################################
      RETURN
      END
