C *********************************************************************      
C    CENTRAL DIFFERENCING SCHEME
C    FOLLOWING PERIC, 1985, P. 62
C *********************************************************************      
      SUBROUTINE CDS3()
      
      USE FELDER      
      USE NO
      
      IMPLICIT NONE      
      
      include 'genrl.inc'
      include 'genrlc.inc'

      DOUBLE PRECISION	dxx1,dxx2,TOL,CALCED,CALCD
	  LOGICAL			TEST
      PARAMETER(		TOL = 1.D-32, TEST = .TRUE.)

	  IF(TEST)THEN

C ---------------------------------------------------------------------
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
C ---------------------------------------------------------------------
C	EAST
      dxx1 = DABS(CALCD(CENTER(I,J,K,1),SMALLE(I,J,K,1)))
      dxx2 = DABS(CALCD(SMALLE(I,J,K,1),CENTER(I+1,J,K,1)))
         IF(DABS(dxx1).GT.TOL)THEN
         FE_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FE_CDS(I,J,K,1) = 0.0D0
         ENDIF
C ---------------------------------------------------------------------
C	NORTH
      dxx1 = DABS(CALCD(CENTER(I,J,K,2),SMALLN(I,J,K,2)))
      dxx2 = DABS(CALCD(SMALLN(I,J,K,2),CENTER(I,J+1,K,2)))
         IF(DABS(dxx1).GT.TOL)THEN
         FN_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FN_CDS(I,J,K,1) = 0.0D0
         ENDIF
C ---------------------------------------------------------------------
C	TOP
      dxx1 = DABS(CALCD(CENTER(I,J,K,3),SMALLT(I,J,K,3)))
      dxx2 = DABS(CALCD(SMALLT(I,J,K,3),CENTER(I,J,K+1,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FT_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FT_CDS(I,J,K,1) = 0.0D0
         ENDIF
C ---------------------------------------------------------------------
C	BOTTOM
      dxx1 = DABS(CALCD(CENTER(I,J,K,3),SMALLB(I,J,K,3)))
      dxx2 = DABS(CALCD(SMALLB(I,J,K,3),CENTER(I,J,K-1,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FB_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FB_CDS(I,J,K,1) = 0.0D0
         ENDIF
C ---------------------------------------------------------------------
C	WEST
      dxx1 = DABS(CALCD(CENTER(I,J,K,1),SMALLW(I,J,K,1)))
      dxx2 = DABS(CALCD(SMALLW(I,J,K,1),CENTER(I-1,J,K,1)))
         IF(DABS(dxx1).GT.TOL)THEN
         FW_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FW_CDS(I,J,K,1) = 0.0D0
         ENDIF
C ---------------------------------------------------------------------
C	SOUTH
      dxx1 = DABS(CALCD(CENTER(I,J,K,2),SMALLS(I,J,K,2)))
      dxx2 = DABS(CALCD(SMALLS(I,J,K,2),CENTER(I,J-1,K,2)))
         IF(DABS(dxx1).GT.TOL)THEN
         FS_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FS_CDS(I,J,K,1) = 0.0D0
         ENDIF
C ---------------------------------------------------------------------
!       FS_CDS(I,J,K,1) = 1.D0-FS_CDS(I,J,K,1)        ! ??????????????
       FN_CDS(I,J,K,1) = 1.D0-FN_CDS(I,J,K,1) 
!        FW_CDS(I,J,K,1) = 1.D0-FW_CDS(I,J,K,1)
       FE_CDS(I,J,K,1) = 1.D0-FE_CDS(I,J,K,1)
!        FB_CDS(I,J,K,1) = 1.D0-FB_CDS(I,J,K,1)
       FT_CDS(I,J,K,1) = 1.D0-FT_CDS(I,J,K,1)

           ENDDO
         ENDDO
      ENDDO

	  ELSE
      
C ---------------------------------------------------------------------
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
C ---------------------------------------------------------------------
!       IF(I.LT.I0)THEN
      dxx1 = DABS(CALCED(
     &      CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     &      SMALLE(I,J,K,1),SMALLE(I,J,K,2),SMALLE(I,J,K,3)))
      dxx2 = DABS(CALCED(
     &      SMALLE(I,J,K,1),SMALLE(I,J,K,2),SMALLE(I,J,K,3),
     &      CENTER(I+1,J,K,1),CENTER(I+1,J,K,2),CENTER(I+1,J,K,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FE_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FE_CDS(I,J,K,1) = 0.0D0
         ENDIF
!       ELSE
!       FE_CDS(I,J,K,1) = 0.5D0
!       ENDIF         
C ---------------------------------------------------------------------
!       IF(J.LT.J0)THEN
      dxx1 = DABS(CALCED(
     &      CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     &      SMALLN(I,J,K,1),SMALLN(I,J,K,2),SMALLN(I,J,K,3)))
      dxx2 = DABS(CALCED(
     &      SMALLN(I,J,K,1),SMALLN(I,J,K,2),SMALLN(I,J,K,3),
     &      CENTER(I,J+1,K,1),CENTER(I,J+1,K,2),CENTER(I,J+1,K,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FN_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FN_CDS(I,J,K,1) = 0.0D0
         ENDIF
!       ELSE
!       FN_CDS(I,J,K,1) = 0.5D0
!       ENDIF
C ---------------------------------------------------------------------
!       IF(K.LT.K0)THEN
      dxx1 = DABS(CALCED(
     &      CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     &      SMALLT(I,J,K,1),SMALLT(I,J,K,2),SMALLT(I,J,K,3)))
      dxx2 = DABS(CALCED(
     &      SMALLT(I,J,K,1),SMALLT(I,J,K,2),SMALLT(I,J,K,3),
     &      CENTER(I,J,K+1,1),CENTER(I,J,K+1,2),CENTER(I,J,K+1,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FT_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FT_CDS(I,J,K,1) = 0.0D0
         ENDIF
!       ELSE      
!       FT_CDS(I,J,K,1) = 0.5D0
!       ENDIF
C ---------------------------------------------------------------------
!       IF(K.GT.1)THEN
      dxx1 = DABS(CALCED(
     &      CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     &      SMALLB(I,J,K,1),SMALLB(I,J,K,2),SMALLB(I,J,K,3))) 
      dxx2 = DABS(CALCED(
     &      SMALLB(I,J,K,1),SMALLB(I,J,K,2),SMALLB(I,J,K,3),
     &      CENTER(I,J,K-1,1),CENTER(I,J,K-1,2),CENTER(I,J,K-1,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FB_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FB_CDS(I,J,K,1) = 0.0D0
         ENDIF
!       ELSE
!       FB_CDS(I,J,K,1) = 0.5D0
!       ENDIF
C ---------------------------------------------------------------------
!       IF(I.GT.1)THEN
      dxx1 = DABS(CALCED(
     &      CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     &      SMALLW(I,J,K,1),SMALLW(I,J,K,2),SMALLW(I,J,K,3)))
      dxx2 = DABS(CALCED(
     &      SMALLW(I,J,K,1),SMALLW(I,J,K,2),SMALLW(I,J,K,3),
     &      CENTER(I-1,J,K,1),CENTER(I-1,J,K,2),CENTER(I-1,J,K,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FW_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FW_CDS(I,J,K,1) = 0.0D0
         ENDIF
!       ELSE
!       FW_CDS(I,J,K,1) = 0.5D0
!       ENDIF      
C ---------------------------------------------------------------------
!       IF(J.GT.1)THEN
      dxx1 = DABS(CALCED(
     &      CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     &      SMALLS(I,J,K,1),SMALLS(I,J,K,2),SMALLS(I,J,K,3))) 
      dxx2 = DABS(CALCED(
     &      SMALLS(I,J,K,1),SMALLS(I,J,K,2),SMALLS(I,J,K,3),
     &      CENTER(I,J-1,K,1),CENTER(I,J-1,K,2),CENTER(I,J-1,K,3)))
         IF(DABS(dxx1).GT.TOL)THEN
         FS_CDS(I,J,K,1) = dxx1/(dxx1 + dxx2)
         ELSE
         FS_CDS(I,J,K,1) = 0.0D0
         ENDIF
!       ELSE
!       FS_CDS(I,J,K,1) = 0.5D0
!       ENDIF
C ---------------------------------------------------------------------
!       FS_CDS(I,J,K,1) = 1.D0-FS_CDS(I,J,K,1)        ! ??????????????
       FN_CDS(I,J,K,1) = 1.D0-FN_CDS(I,J,K,1) 
!       FW_CDS(I,J,K,1) = 1.D0-FW_CDS(I,J,K,1)
       FE_CDS(I,J,K,1) = 1.D0-FE_CDS(I,J,K,1)
!       FB_CDS(I,J,K,1) = 1.D0-FB_CDS(I,J,K,1)
       FT_CDS(I,J,K,1) = 1.D0-FT_CDS(I,J,K,1)

            ENDDO
         ENDDO
      ENDDO

	  ENDIF

      RETURN
      END
