C *********************************************************************      
C    HEAD CENTRAL DIFFERENCING SCHEME
C    FOLLOWING PERIC, 1985, S. 76
C *********************************************************************      
      SUBROUTINE CDS3_D()
      
      USE FELDER      
      USE NO
      
      IMPLICIT NONE      
      
      include 'genrl.inc'
      include 'genrlc.inc'      
      include 'flow.inc'

      INTEGER  IS1,JS1,KS1,IS2,JS2,KS2,WI,IP2,JP2,KP2,I2,J2,K2
      
      IF(LINFO.GE.2) WRITE(*,*)'CDS3_D working'    
C ---------------------------------------------------------------------
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
C SEE PERIC, 1985, page 76
      IF(J.LT.J0)THEN
      D_n(I,J,K)=
     &(DICHTE(I,J+1,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*FN_CDS(I,J,K,1)+
     &(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*(1.D0-FN_CDS(I,J,K,1))
      ELSE
      D_n(I,J,K)=(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)
      ENDIF
      IF(J.GT.1)THEN
      D_s(I,J,K)=
     &(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*FS_CDS(I,J,K,1)+
     &(DICHTE(I,J-1,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*(1.D0-FS_CDS(I,J,K,1))
      ELSE
      D_s(I,J,K)=(DICHTE(I,J,K) -RHOF0(I,J,K))/RHOF0(I,J,K)     
      ENDIF
      IF(K.LT.K0)THEN
      D_t(I,J,K)=
     &(DICHTE(I,J,K+1)-RHOF0(I,J,K))/RHOF0(I,J,K)*FT_CDS(I,J,K,1)+
     &(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*(1.D0-FT_CDS(I,J,K,1))
      ELSE
      D_t(I,J,K)=(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)
      ENDIF
      IF(K.GT.1)THEN
      D_b(I,J,K)=
     &(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*FB_CDS(I,J,K,1)+
     &(DICHTE(I,J,K-1)-RHOF0(I,J,K))/RHOF0(I,J,K)*(1.D0-FB_CDS(I,J,K,1))
      ELSE
      D_b(I,J,K)=(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)
      ENDIF
      IF(I.LT.I0)THEN
      D_e(I,J,K)=
     &(DICHTE(I+1,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*FE_CDS(I,J,K,1)+
     &(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*(1.D0-FE_CDS(I,J,K,1))
      ELSE
      D_e(I,J,K)=(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)
      ENDIF
      IF(I.GT.1)THEN
      D_w(I,J,K)=
     &(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*FW_CDS(I,J,K,1)+
     &(DICHTE(I-1,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)*(1.D0-FW_CDS(I,J,K,1))
      ELSE
      D_w(I,J,K)=(DICHTE(I,J,K)-RHOF0(I,J,K))/RHOF0(I,J,K)
      ENDIF
           ENDDO
         ENDDO
      ENDDO
      
C ######################################################################
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
            IF(I.EQ.1)THEN
            IP2 = I-1
            JP2 = J
            KP2 = K
C     WEST
            D_e(IP2,JP2,KP2)=D_w(I,J,K)   !
            D_n(IP2,JP2,KP2)=D_n(I,J,K)
            D_t(IP2,JP2,KP2)=D_t(I,J,K)
            D_w(IP2,JP2,KP2)=D_w(I,J,K)
            D_s(IP2,JP2,KP2)=D_s(I,J,K)
            D_b(IP2,JP2,KP2)=D_b(I,J,K)
            ENDIF
            IF(I.EQ.I0)THEN
            IP2 = I+1
            JP2 = J
            KP2 = K
C     EAST            
            D_e(IP2,JP2,KP2)=D_e(I,J,K)
            D_n(IP2,JP2,KP2)=D_n(I,J,K)
            D_t(IP2,JP2,KP2)=D_t(I,J,K)
            D_w(IP2,JP2,KP2)=D_e(I,J,K)   !
            D_s(IP2,JP2,KP2)=D_s(I,J,K)
            D_b(IP2,JP2,KP2)=D_b(I,J,K)
            ENDIF
            IF(J.EQ.1)THEN
            IP2 = I
            JP2 = J-1
            KP2 = K
C     SOUTH
            D_e(IP2,JP2,KP2)=D_e(I,J,K)
            D_n(IP2,JP2,KP2)=D_s(I,J,K)   !
            D_t(IP2,JP2,KP2)=D_t(I,J,K)
            D_w(IP2,JP2,KP2)=D_w(I,J,K)
            D_s(IP2,JP2,KP2)=D_s(I,J,K)
            D_b(IP2,JP2,KP2)=D_b(I,J,K)
            ENDIF
            IF(J.EQ.J0)THEN
            IP2 = I
            JP2 = J+1
            KP2 = K
C     NORTH
            D_e(IP2,JP2,KP2)=D_e(I,J,K)
            D_n(IP2,JP2,KP2)=D_n(I,J,K)
            D_t(IP2,JP2,KP2)=D_t(I,J,K)
            D_w(IP2,JP2,KP2)=D_w(I,J,K)
            D_s(IP2,JP2,KP2)=D_n(I,J,K)   !
            D_b(IP2,JP2,KP2)=D_b(I,J,K)
            ENDIF
            IF(K.EQ.1)THEN
            IP2 = I
            JP2 = J
            KP2 = K-1
C     BOTTOM            
            D_e(IP2,JP2,KP2)=D_e(I,J,K)
            D_n(IP2,JP2,KP2)=D_n(I,J,K)
            D_t(IP2,JP2,KP2)=D_b(I,J,K)   !
            D_w(IP2,JP2,KP2)=D_w(I,J,K)
            D_s(IP2,JP2,KP2)=D_s(I,J,K)
            D_b(IP2,JP2,KP2)=D_b(I,J,K)
            ENDIF
            IF(K.EQ.K0)THEN
            IP2 = I
            JP2 = J
            KP2 = K+1
C     TOP
            D_e(IP2,JP2,KP2)=D_e(I,J,K)
            D_n(IP2,JP2,KP2)=D_n(I,J,K)
            D_t(IP2,JP2,KP2)=D_t(I,J,K)
            D_w(IP2,JP2,KP2)=D_w(I,J,K)
            D_s(IP2,JP2,KP2)=D_s(I,J,K)
            D_b(IP2,JP2,KP2)=D_t(I,J,K)   !
            ENDIF
            ENDDO
         ENDDO
      ENDDO
C ######################################################################
      RETURN
      END
