C *********************************************************************      
C    HEAD CENTRAL DIFFERENCING SCHEME
C    FOLLOWING PERIC, 1985, S. 76
C *********************************************************************      
      SUBROUTINE CDS3_P()
      
      USE FELDER      
      USE NO
      
      IMPLICIT NONE      
      
      include 'genrl.inc'
      include 'genrlc.inc'      
      include 'flow.inc'

      INTEGER  IS1,JS1,KS1,IS2,JS2,KS2,WI,IP2,JP2,KP2,I2,J2,K2
      
      IF(LINFO.GE.2) WRITE(*,*)'CDS3_P working'    
C ---------------------------------------------------------------------
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
C SEE PERIC, 1985, page 76
              IF(J.EQ.J0.AND.SEITEF(4).EQ.'HEAD')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
              ELSE
            P_n(I,J,K)=
     & phi0(I,J+1,K)*FN_CDS(I,J,K,1)+phi0(I,J,K)*(1.D0-FN_CDS(I,J,K,1))
              ENDIF
              IF(J.EQ.1.AND.SEITEF(2).EQ.'HEAD')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
              ELSE
            P_s(I,J,K)=
     & phi0(I,J,K)*FS_CDS(I,J,K,1)+phi0(I,J-1,K)*(1.D0-FS_CDS(I,J,K,1))
              ENDIF
              IF(K.EQ.K0.AND.TOPF.EQ.'HEAD')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
              ELSE
            P_t(I,J,K)=
     & phi0(I,J,K+1)*FT_CDS(I,J,K,1)+phi0(I,J,K)*(1.D0-FT_CDS(I,J,K,1))
              ENDIF
              IF(K.EQ.1.AND.BASEF.EQ.'HEAD')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
              ELSE
            P_b(I,J,K)=
     & phi0(I,J,K)*FB_CDS(I,J,K,1)+phi0(I,J,K-1)*(1.D0-FB_CDS(I,J,K,1))
              ENDIF
              IF(I.EQ.I0.AND.SEITEF(3).EQ.'HEAD')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
              ELSE
            P_e(I,J,K)=
     & phi0(I+1,J,K)*FE_CDS(I,J,K,1)+phi0(I,J,K)*(1.D0-FE_CDS(I,J,K,1))
              ENDIF
              IF(I.EQ.1.AND.SEITEF(1).EQ.'HEAD')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
              ELSE
            P_w(I,J,K)=
     & phi0(I,J,K)*FW_CDS(I,J,K,1)+phi0(I-1,J,K)*(1.D0-FW_CDS(I,J,K,1))
              ENDIF
           ENDDO
         ENDDO
      ENDDO
      
C ######################################################################
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
            IF(I.EQ.1)THEN
            IP2 = I-1
            JP2 = J
            KP2 = K
C     WEST
            p_e(IP2,JP2,KP2)=p_w(I,J,K)   !
            p_n(IP2,JP2,KP2)=p_n(I,J,K)
            p_t(IP2,JP2,KP2)=p_t(I,J,K)
            p_w(IP2,JP2,KP2)=p_w(I,J,K)
            p_s(IP2,JP2,KP2)=p_s(I,J,K)
            p_b(IP2,JP2,KP2)=p_b(I,J,K)
            ENDIF
            IF(I.EQ.I0)THEN
            IP2 = I+1
            JP2 = J
            KP2 = K
C     EAST            
            p_e(IP2,JP2,KP2)=p_e(I,J,K)
            p_n(IP2,JP2,KP2)=p_n(I,J,K)
            p_t(IP2,JP2,KP2)=p_t(I,J,K)
            p_w(IP2,JP2,KP2)=p_e(I,J,K)   !
            p_s(IP2,JP2,KP2)=p_s(I,J,K)
            p_b(IP2,JP2,KP2)=p_b(I,J,K)
            ENDIF
            IF(J.EQ.1)THEN
            IP2 = I
            JP2 = J-1
            KP2 = K
C     SOUTH
            p_e(IP2,JP2,KP2)=p_e(I,J,K)
            p_n(IP2,JP2,KP2)=p_s(I,J,K)   !
            p_t(IP2,JP2,KP2)=p_t(I,J,K)
            p_w(IP2,JP2,KP2)=p_w(I,J,K)
            p_s(IP2,JP2,KP2)=p_s(I,J,K)
            p_b(IP2,JP2,KP2)=p_b(I,J,K)
            ENDIF
            IF(J.EQ.J0)THEN
            IP2 = I
            JP2 = J+1
            KP2 = K
C     NORTH
            p_e(IP2,JP2,KP2)=p_e(I,J,K)
            p_n(IP2,JP2,KP2)=p_n(I,J,K)
            p_t(IP2,JP2,KP2)=p_t(I,J,K)
            p_w(IP2,JP2,KP2)=p_w(I,J,K)
            p_s(IP2,JP2,KP2)=p_n(I,J,K)   !
            p_b(IP2,JP2,KP2)=p_b(I,J,K)
            ENDIF
            IF(K.EQ.1)THEN
            IP2 = I
            JP2 = J
            KP2 = K-1
C     BOTTOM            
            p_e(IP2,JP2,KP2)=p_e(I,J,K)
            p_n(IP2,JP2,KP2)=p_n(I,J,K)
            p_t(IP2,JP2,KP2)=p_b(I,J,K)   !
            p_w(IP2,JP2,KP2)=p_w(I,J,K)
            p_s(IP2,JP2,KP2)=p_s(I,J,K)
            p_b(IP2,JP2,KP2)=p_b(I,J,K)
            ENDIF
            IF(K.EQ.K0)THEN
            IP2 = I
            JP2 = J
            KP2 = K+1
C     TOP
            p_e(IP2,JP2,KP2)=p_e(I,J,K)
            p_n(IP2,JP2,KP2)=p_n(I,J,K)
            p_t(IP2,JP2,KP2)=p_t(I,J,K)
            p_w(IP2,JP2,KP2)=p_w(I,J,K)
            p_s(IP2,JP2,KP2)=p_s(I,J,K)
            p_b(IP2,JP2,KP2)=p_t(I,J,K)   !
            ENDIF
            ENDDO
         ENDDO
      ENDDO
C ######################################################################
      RETURN
      END
