C *********************************************************************      
C    TEMPERATURE CENTRAL DIFFERENCING SCHEME
C    FOLLOWING PERIC, 1985, S. 76
C *********************************************************************      
      SUBROUTINE CDS3_T()
      
      USE FELDER      
      USE NO
      
      IMPLICIT NONE      
      
      include 'genrl.inc'
      include 'genrlc.inc'
      include 'temp.inc'
      INTEGER  IS1,JS1,KS1,IS2,JS2,KS2,WI,IP2,JP2,KP2,I2,J2,K2
      
      IF(LINFO.GE.2) WRITE(*,*)'CDS3_T working'  
C ---------------------------------------------------------------------
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
C SEE PERIC, 1985, page 76
               IF(J.EQ.J0.AND.SEITET(4).EQ.'TEMP')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
               ELSE
               TEMP_n(I,J,K)=
     & TP0(I,J+1,K)*FN_CDS(I,J,K,1)+TP0(I,J,K)*(1.D0-FN_CDS(I,J,K,1))
               ENDIF
               IF(J.EQ.1.AND.SEITET(2).EQ.'TEMP')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
               ELSE
               TEMP_s(I,J,K)=
     & TP0(I,J,K)*FS_CDS(I,J,K,1)+TP0(I,J-1,K)*(1.D0-FS_CDS(I,J,K,1))
               ENDIF
               IF(K.EQ.K0.AND.TOPT.EQ.'TEMP')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
               ELSE
               TEMP_t(I,J,K)=
     & TP0(I,J,K+1)*FT_CDS(I,J,K,1)+TP0(I,J,K)*(1.D0-FT_CDS(I,J,K,1))
               ENDIF
               IF(K.EQ.1.AND.BASET.EQ.'TEMP')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
               ELSE
               TEMP_b(I,J,K)=
     & TP0(I,J,K)*FB_CDS(I,J,K,1)+TP0(I,J,K-1)*(1.D0-FB_CDS(I,J,K,1))
               ENDIF
               IF(I.EQ.I0.AND.SEITET(3).EQ.'TEMP')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
               ELSE
               TEMP_e(I,J,K)=
     & TP0(I+1,J,K)*FE_CDS(I,J,K,1)+TP0(I,J,K)*(1.D0-FE_CDS(I,J,K,1))
               ENDIF
               IF(I.EQ.1.AND.SEITET(1).EQ.'TEMP')THEN
C DO NOTHING, KEEP VALUE, BECAUSE IT IS A BOUNDARY CONDITION
               ELSE
               TEMP_w(I,J,K)=
     & TP0(I,J,K)*FW_CDS(I,J,K,1)+TP0(I-1,J,K)*(1.D0-FW_CDS(I,J,K,1))
               ENDIF
           ENDDO
         ENDDO
      ENDDO
      
C ######################################################################
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
            IF(I.EQ.1)THEN
            IP2 = I-1
            JP2 = J
            KP2 = K
C     WEST
            TEMP_e(IP2,JP2,KP2)=TEMP_w(I,J,K)   !
            TEMP_n(IP2,JP2,KP2)=TEMP_n(I,J,K)
            TEMP_t(IP2,JP2,KP2)=TEMP_t(I,J,K)
            TEMP_w(IP2,JP2,KP2)=TEMP_w(I,J,K)
            TEMP_s(IP2,JP2,KP2)=TEMP_s(I,J,K)
            TEMP_b(IP2,JP2,KP2)=TEMP_b(I,J,K)
            ENDIF
            IF(I.EQ.I0)THEN
            IP2 = I+1
            JP2 = J
            KP2 = K
C     EAST            
            TEMP_e(IP2,JP2,KP2)=TEMP_e(I,J,K)
            TEMP_n(IP2,JP2,KP2)=TEMP_n(I,J,K)
            TEMP_t(IP2,JP2,KP2)=TEMP_t(I,J,K)
            TEMP_w(IP2,JP2,KP2)=TEMP_e(I,J,K)   !
            TEMP_s(IP2,JP2,KP2)=TEMP_s(I,J,K)
            TEMP_b(IP2,JP2,KP2)=TEMP_b(I,J,K)
            ENDIF
            IF(J.EQ.1)THEN
            IP2 = I
            JP2 = J-1
            KP2 = K
C     SOUTH
            TEMP_e(IP2,JP2,KP2)=TEMP_e(I,J,K)
            TEMP_n(IP2,JP2,KP2)=TEMP_s(I,J,K)   !
            TEMP_t(IP2,JP2,KP2)=TEMP_t(I,J,K)
            TEMP_w(IP2,JP2,KP2)=TEMP_w(I,J,K)
            TEMP_s(IP2,JP2,KP2)=TEMP_s(I,J,K)
            TEMP_b(IP2,JP2,KP2)=TEMP_b(I,J,K)
            ENDIF
            IF(J.EQ.J0)THEN
            IP2 = I
            JP2 = J+1
            KP2 = K
C     NORTH
            TEMP_e(IP2,JP2,KP2)=TEMP_e(I,J,K)
            TEMP_n(IP2,JP2,KP2)=TEMP_n(I,J,K)
            TEMP_t(IP2,JP2,KP2)=TEMP_t(I,J,K)
            TEMP_w(IP2,JP2,KP2)=TEMP_w(I,J,K)
            TEMP_s(IP2,JP2,KP2)=TEMP_n(I,J,K)   !
            TEMP_b(IP2,JP2,KP2)=TEMP_b(I,J,K)
            ENDIF
            IF(K.EQ.1)THEN
            IP2 = I
            JP2 = J
            KP2 = K-1
C     BOTTOM            
            TEMP_e(IP2,JP2,KP2)=TEMP_e(I,J,K)
            TEMP_n(IP2,JP2,KP2)=TEMP_n(I,J,K)
            TEMP_t(IP2,JP2,KP2)=TEMP_b(I,J,K)   !
            TEMP_w(IP2,JP2,KP2)=TEMP_w(I,J,K)
            TEMP_s(IP2,JP2,KP2)=TEMP_s(I,J,K)
            TEMP_b(IP2,JP2,KP2)=TEMP_b(I,J,K)
            ENDIF
            IF(K.EQ.K0)THEN
            IP2 = I
            JP2 = J
            KP2 = K+1
C     TOP
            TEMP_e(IP2,JP2,KP2)=TEMP_e(I,J,K)
            TEMP_n(IP2,JP2,KP2)=TEMP_n(I,J,K)
            TEMP_t(IP2,JP2,KP2)=TEMP_t(I,J,K)
            TEMP_w(IP2,JP2,KP2)=TEMP_w(I,J,K)
            TEMP_s(IP2,JP2,KP2)=TEMP_s(I,J,K)
            TEMP_b(IP2,JP2,KP2)=TEMP_t(I,J,K)   !
            ENDIF
            ENDDO
         ENDDO
      ENDDO
C ######################################################################
      RETURN
      END
