C **********************************************************************
C     Wolfram Ruehaak, 05/01/22
C **********************************************************************
C
C **********************************************************************
      SUBROUTINE CALCEDGES()

      USE FEARRAYS
      
      IMPLICIT NONE
      
      INCLUDE 'nogrid.fi'
      INCLUDE 'transf3d.fi'
      CHARACTER NNN(5,4)*8
      INTEGER   J
      INTEGER   NNX,NNY,NNZ,II7,JJ7,KK7

C ---------------------------------------------------------------------

      DO AW1 = 1, NE
C
C     ES FOLGT DIE BERECHNUNG DER KOORDINATEN DER KNOTEN AUF DEN 
C     CV-KANTEN (12 STUECK):
C
C     NE: dies liegt auf in der Mitte von (3) und (7)
      CALL CALCEM(XWR3(AW1),YWR3(AW1),ZWR3(AW1),
     +            XWR7(AW1),YWR7(AW1),ZWR7(AW1),
     +      XX0(1,1),YY0(1,1),ZZ0(1,1),ED(1,1))
C     SE: dies liegt auf in der Mitte von (2) und (6)
      CALL CALCEM(XWR2(AW1),YWR2(AW1),ZWR2(AW1),
     +            XWR6(AW1),YWR6(AW1),ZWR6(AW1),
     +      XX0(1,2),YY0(1,2),ZZ0(1,2),ED(1,2))
C     SW: dies liegt auf in der Mitte von (1) und (5)
      CALL CALCEM(XWR1(AW1),YWR1(AW1),ZWR1(AW1),
     +            XWR5(AW1),YWR5(AW1),ZWR5(AW1),
     +      XX0(1,3),YY0(1,3),ZZ0(1,3),ED(1,3))
C     NW: dies liegt auf in der Mitte von (4) und (8)
      CALL CALCEM(XWR4(AW1),YWR4(AW1),ZWR4(AW1),
     +            XWR8(AW1),YWR8(AW1),ZWR8(AW1),
     +      XX0(1,4),YY0(1,4),ZZ0(1,4),ED(1,4))

C     TE: dies liegt auf in der Mitte von (3) und (2)
      CALL CALCEM(XWR3(AW1),YWR3(AW1),ZWR3(AW1),
     +            XWR2(AW1),YWR2(AW1),ZWR2(AW1),
     +      XX0(2,1),YY0(2,1),ZZ0(2,1),ED(2,1))
C     TS: dies liegt auf in der Mitte von (2) und (1)
      CALL CALCEM(XWR2(AW1),YWR2(AW1),ZWR2(AW1),
     +            XWR1(AW1),YWR1(AW1),ZWR1(AW1),
     +      XX0(2,2),YY0(2,2),ZZ0(2,2),ED(2,2))
C     TW: dies liegt auf in der Mitte von (1) und (4)
      CALL CALCEM(XWR1(AW1),YWR1(AW1),ZWR1(AW1),
     +            XWR4(AW1),YWR4(AW1),ZWR4(AW1),
     +      XX0(2,3),YY0(2,3),ZZ0(2,3),ED(2,3))
C     TN: dies liegt auf in der Mitte von (4) und (3)
      CALL CALCEM(XWR4(AW1),YWR4(AW1),ZWR4(AW1),
     +            XWR3(AW1),YWR3(AW1),ZWR3(AW1),
     +      XX0(2,4),YY0(2,4),ZZ0(2,4),ED(2,4))
      
C     BE: dies liegt auf in der Mitte von (7) und (6)
      CALL CALCEM(XWR7(AW1),YWR7(AW1),ZWR7(AW1),
     +            XWR6(AW1),YWR6(AW1),ZWR6(AW1),
     +      XX0(3,1),YY0(3,1),ZZ0(3,1),ED(3,1))
C     BS: dies liegt auf in der Mitte von (6) und (5)
      CALL CALCEM(XWR6(AW1),YWR6(AW1),ZWR6(AW1),
     +            XWR5(AW1),YWR5(AW1),ZWR5(AW1),
     +      XX0(3,2),YY0(3,2),ZZ0(3,2),ED(3,2))
C     BW: dies liegt auf in der Mitte von (5) und (8)
      CALL CALCEM(XWR5(AW1),YWR5(AW1),ZWR5(AW1),
     +            XWR8(AW1),YWR8(AW1),ZWR8(AW1),
     +      XX0(3,3),YY0(3,3),ZZ0(3,3),ED(3,3))
C     BN: dies liegt auf in der Mitte von (8) und (7)
      CALL CALCEM(XWR8(AW1),YWR8(AW1),ZWR8(AW1),
     +            XWR7(AW1),YWR7(AW1),ZWR7(AW1),
     +      XX0(3,4),YY0(3,4),ZZ0(3,4),ED(3,4))                  

C     P: dies liegt auf in der Mitte von () und ()
C     == MCENTER(NRELEMENTS,3)      
C      CALL CALCEM(X8,Y8,Z8,X7,Y7,Z7,X(5,3),Y(5,3),Z(5,3),ED(5,3))
      
      XX0(5,3) = MCENTER(AW1,1) 
      YY0(5,3) = MCENTER(AW1,2)
      ZZ0(5,3) = MCENTER(AW1,3)
      
C     ED(5,3)

C *********************************************************************      
      XWR(AW1,1,1) = XX0(1,1) ! 1: ne
      XWR(AW1,1,2) = XX0(1,2) ! 2: se
      XWR(AW1,1,3) = XX0(1,3) ! 3: sw
      XWR(AW1,1,4) = XX0(1,4) ! 4: nw
      XWR(AW1,2,1) = XX0(2,1) ! 5: te
      XWR(AW1,2,2) = XX0(2,2) ! 6: ts
      XWR(AW1,2,3) = XX0(2,3) ! 7: tw
      XWR(AW1,2,4) = XX0(2,4) ! 8: tn
      XWR(AW1,3,1) = XX0(3,1) ! 9: be
      XWR(AW1,3,2) = XX0(3,2) ! 10: bs
      XWR(AW1,3,3) = XX0(3,3) ! 11: bw
      XWR(AW1,3,4) = XX0(3,4) ! 12: bn
      
      XWR(AW1,5,3) = XX0(5,3) ! 19: P
      XWR(AW1,5,4) = 0.D0
               
      YWR(AW1,1,1) = YY0(1,1) ! 1: ne
      YWR(AW1,1,2) = YY0(1,2) ! 2: se
      YWR(AW1,1,3) = YY0(1,3) ! 3: sw
      YWR(AW1,1,4) = YY0(1,4) ! 4: nw
      YWR(AW1,2,1) = YY0(2,1) ! 5: te
      YWR(AW1,2,2) = YY0(2,2) ! 6: ts
      YWR(AW1,2,3) = YY0(2,3) ! 7: tw
      YWR(AW1,2,4) = YY0(2,4) ! 8: tn
      YWR(AW1,3,1) = YY0(3,1) ! 9: be
      YWR(AW1,3,2) = YY0(3,2) ! 10: bs
      YWR(AW1,3,3) = YY0(3,3) ! 11: bw
      YWR(AW1,3,4) = YY0(3,4) ! 12: bn
      
      YWR(AW1,5,3) = YY0(5,3) ! 19: P
      YWR(AW1,5,4) = 0.D0
      
      ZWR(AW1,1,1) = ZZ0(1,1) ! 1: ne
      ZWR(AW1,1,2) = ZZ0(1,2) ! 2: se
      ZWR(AW1,1,3) = ZZ0(1,3) ! 3: sw
      ZWR(AW1,1,4) = ZZ0(1,4) ! 4: nw
      ZWR(AW1,2,1) = ZZ0(2,1) ! 5: te
      ZWR(AW1,2,2) = ZZ0(2,2) ! 6: ts
      ZWR(AW1,2,3) = ZZ0(2,3) ! 7: tw
      ZWR(AW1,2,4) = ZZ0(2,4) ! 8: tn
      ZWR(AW1,3,1) = ZZ0(3,1) ! 9: be
      ZWR(AW1,3,2) = ZZ0(3,2) ! 10: bs
      ZWR(AW1,3,3) = ZZ0(3,3) ! 11: bw
      ZWR(AW1,3,4) = ZZ0(3,4) ! 12: bn
      
      ZWR(AW1,5,3) = ZZ0(5,3) ! 19: P
      ZWR(AW1,5,4) = 0.D0
C *********************************************************************
      
!       DO I = 1, 5
!       DO J = 1, 4
!       WRITE(76,'(A8,1X,3(F20.5,1X))') 
!      +NNN(I,J),XX0(I,J),YY0(I,J),ZZ0(I,J)
!       ENDDO
!       ENDDO
      
      ENDDO
      
      RETURN
      END
