C **********************************************************************
C     Wolfram Ruehaak, 05/03/21
C **********************************************************************
C
C **********************************************************************         
      SUBROUTINE CALCFACES()
      
      USE FEARRAYS
      
      IMPLICIT NONE
      
      INCLUDE 'nogrid.fi'
      INCLUDE 'transf3d.fi'
      CHARACTER NNN(5,4)*8
      INTEGER   J
      INTEGER   NNX,NNY,NNZ,II7,JJ7,KK7

! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!         
!         
!     CAUTION !!! 
!     THESE VARIABLES WILL BE RENAMED  IN SUBROUTINE REINDEX 
!     INTO SMALLE, SMALLN, SMALLT, ... !!!
!     BECAUSE THESE POINTS HAVE TO BE THE CENTERS OF THE NEIGHBORING CELLS!
!     BUT WE STILL NEED THESE SMALLE, ... FOR A LOT OF CALCULATIONS,
!     BUT FOR THE MAIN TRANSFORMATION WE NEED THE NEIGHBORS INSTEAD!
! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
      DO AW1 = 1, NE
      
C     E: dies ist der Schnittpunkt in der y/z-Ebene von 
C           (2,7) und (3,6)
C  NEU!: te - be, ne - se :: (2,1) - (3,1), (1,1) - (1,2)
C
      XX0(4,1) = 
     + .25D0 * (XWR(AW1,2,1)+XWR(AW1,3,1)+XWR(AW1,1,1)+XWR(AW1,1,2))
      YY0(4,1) = 
     + .25D0 * (YWR(AW1,2,1)+YWR(AW1,3,1)+YWR(AW1,1,1)+YWR(AW1,1,2))
      ZZ0(4,1) = 
     + .25D0 * (ZWR(AW1,2,1)+ZWR(AW1,3,1)+ZWR(AW1,1,1)+ZWR(AW1,1,2))

C     s: dies ist der Schnittpunkt in der x/z-Ebene von 
C           (1,6) und (2,5) ...
C  NEU!: ts - bs, se - sw : (2,2) - (3,2), (1,2) - (1,3)
C
      XX0(4,2) = 
     + .25D0 * (XWR(AW1,2,2)+XWR(AW1,3,2)+XWR(AW1,1,2)+XWR(AW1,1,3))
      YY0(4,2) = 
     + .25D0 * (YWR(AW1,2,2)+YWR(AW1,3,2)+YWR(AW1,1,2)+YWR(AW1,1,3))
      ZZ0(4,2) = 
     + .25D0 * (ZWR(AW1,2,2)+ZWR(AW1,3,2)+ZWR(AW1,1,2)+ZWR(AW1,1,3))

C     w: dies ist der Schnittpunkt in der y/z-Ebene von 
C           (1,8) und (4,5) ...
C  NEU!: tw - bw, nw - sw :: (2,3) - (3,3) , (1,4) - (1,3)
C
      XX0(4,3) = 
     + .25D0 * (XWR(AW1,2,3)+XWR(AW1,3,3)+XWR(AW1,1,4)+XWR(AW1,1,3))
      YY0(4,3) = 
     + .25D0 * (YWR(AW1,2,3)+YWR(AW1,3,3)+YWR(AW1,1,4)+YWR(AW1,1,3))
      ZZ0(4,3) = 
     + .25D0 * (ZWR(AW1,2,3)+ZWR(AW1,3,3)+ZWR(AW1,1,4)+ZWR(AW1,1,3))

C     n: dies ist der Schnittpunkt in der x/z-Ebene von 
C           (4,7) und (3,8) ...
C  NEU!: tn - bn, ne - nw :: (2,4) - (3,4), (1,1) - (1,4)
C
      XX0(4,4) = 
     + .25D0 * (XWR(AW1,2,4)+XWR(AW1,3,4)+XWR(AW1,1,1)+XWR(AW1,1,4))
      YY0(4,4) = 
     + .25D0 * (YWR(AW1,2,4)+YWR(AW1,3,4)+YWR(AW1,1,1)+YWR(AW1,1,4))
      ZZ0(4,4) = 
     + .25D0 * (ZWR(AW1,2,4)+ZWR(AW1,3,4)+ZWR(AW1,1,1)+ZWR(AW1,1,4))

C     t: dies ist der Schnittpunkt in der x/y-Ebene von 
C           (1,3) und (2,4) ...
C  NEU!: tn - ts, te - tw :: (2,4) - (2,2), (2,1) - (2,3)
C
      XX0(5,1) = 
     + .25D0 * (XWR(AW1,2,4)+XWR(AW1,2,2)+XWR(AW1,2,1)+XWR(AW1,2,3))
      YY0(5,1) = 
     + .25D0 * (YWR(AW1,2,4)+YWR(AW1,2,2)+YWR(AW1,2,1)+YWR(AW1,2,3))
      ZZ0(5,1) = 
     + .25D0 * (ZWR(AW1,2,4)+ZWR(AW1,2,2)+ZWR(AW1,2,1)+ZWR(AW1,2,3))

C     b: dies ist der Schnittpunkt in der x/y-Ebene von 
C           (5,7) und (6,8) ...
C  NEU!: bn - bs, be - bw :: (3,4) - (3,2), (3,1) - 3,3)
C
      XX0(5,2) = 
     + .25D0 * (XWR(AW1,3,4)+XWR(AW1,3,2)+XWR(AW1,3,1)+XWR(AW1,3,3))
      YY0(5,2) = 
     + .25D0 * (YWR(AW1,3,4)+YWR(AW1,3,2)+YWR(AW1,3,1)+YWR(AW1,3,3))
      ZZ0(5,2) = 
     + .25D0 * (ZWR(AW1,3,4)+ZWR(AW1,3,2)+ZWR(AW1,3,1)+ZWR(AW1,3,3))

C *********************************************************************
      XWR(AW1,4,1) = XX0(4,1) ! 13: e
      XWR(AW1,4,2) = XX0(4,2) ! 14: s
      XWR(AW1,4,3) = XX0(4,3) ! 15: w
      XWR(AW1,4,4) = XX0(4,4) ! 16: n
      XWR(AW1,5,1) = XX0(5,1) ! 17: t 
      XWR(AW1,5,2) = XX0(5,2) ! 18: b
      
      YWR(AW1,4,1) = YY0(4,1) ! 13: e
      YWR(AW1,4,2) = YY0(4,2) ! 14: s
      YWR(AW1,4,3) = YY0(4,3) ! 15: w
      YWR(AW1,4,4) = YY0(4,4) ! 16: n
      YWR(AW1,5,1) = YY0(5,1) ! 17: t 
      YWR(AW1,5,2) = YY0(5,2) ! 18: b
      
      ZWR(AW1,4,1) = ZZ0(4,1) ! 13: e
      ZWR(AW1,4,2) = ZZ0(4,2) ! 14: s
      ZWR(AW1,4,3) = ZZ0(4,3) ! 15: w
      ZWR(AW1,4,4) = ZZ0(4,4) ! 16: n
      ZWR(AW1,5,1) = ZZ0(5,1) ! 17: t 
      ZWR(AW1,5,2) = ZZ0(5,2) ! 18: b
C *********************************************************************

      ENDDO
      
      RETURN
      END
