C
C     CALCULATE TETRAHEDRON CENTER
C
      SUBROUTINE CALCTETCENTER()
     
      USE FEARRAYS
      USE NO
      IMPLICIT NONE
      
      INCLUDE 'nogrid.fi'

C     LOCALE VARIABLEN      
      DOUBLE PRECISION  KND1(3),KND2(3),KND3(3),KND4(3),VOLTH,
     &                  div,SVOL2, DIFF, PDIFF,DET
      DOUBLE PRECISION  TCENTER(3),ALPHA(4),RAD1,RAD2,RAD3,RAD4,RAD5
      LOGICAL           DEGEN

      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VOL1(:) ! NE)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VOL2(:) ! NE)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VOL3(:) ! NE)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VOL4(:) ! NE)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VOL5(:) ! NE)
     
      DOUBLE PRECISION 
     & TC1X,TC1Y,TC1Z,
     & TC2X,TC2Y,TC2Z,
     & TC3X,TC3Y,TC3Z,
     & TC4X,TC4Y,TC4Z,
     & TC5X,TC5Y,TC5Z
      DOUBLE PRECISION WEIGHT
      INTEGER I
      DOUBLE PRECISION DXSCR1,DXSCR2,DXSCR3,DXSCR4
      DOUBLE PRECISION DYSCR1,DYSCR2,DYSCR3,DYSCR4
      DOUBLE PRECISION DZSCR1,DZSCR2,DZSCR3,DZSCR4
      DOUBLE PRECISION MSCR(3)
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      ALLOCATE(VOL1(NE))
      ALLOCATE(VOL2(NE))
      ALLOCATE(VOL3(NE))
      ALLOCATE(VOL4(NE))
      ALLOCATE(VOL5(NE))

      IF(DBG_WR)THEN
      CLOSE(73)
      OPEN(73,FILE='calctetcenter.out')
      ENDIF


      div = 1.D0/6.D0

      DO I = 1, NE
C     1. TETRAEDER
C     TETR1 = (1,2,3,6)
      KND1(1) = XWR1(I)
      KND1(2) = YWR1(I)
      KND1(3) = ZWR1(I)
      KND2(1) = XWR2(I)
      KND2(2) = YWR2(I)
      KND2(3) = ZWR2(I)
      KND3(1) = XWR3(I)
      KND3(2) = YWR3(I)
      KND3(3) = ZWR3(I)
      KND4(1) = XWR6(I)
      KND4(2) = YWR6(I)
      KND4(3) = ZWR6(I)
      VOL1(I) = div*VOLTH(KND1, KND2, KND3, KND4)
      CALL INSPH(KND1,KND2,KND3,KND4,TCENTER,RAD1)
        
      TC1X = TCENTER(1)
      TC1Y = TCENTER(2)
      TC1Z = TCENTER(3)

C     2. TETRAEDER
C	TETR2 = (1,5,6,8)
      KND1(1) = XWR1(I)
      KND1(2) = YWR1(I)
      KND1(3) = ZWR1(I)
      KND2(1) = XWR5(I)
      KND2(2) = YWR5(I)
      KND2(3) = ZWR5(I)
      KND3(1) = XWR6(I)
      KND3(2) = YWR6(I)
      KND3(3) = ZWR6(I)
      KND4(1) = XWR8(I)
      KND4(2) = YWR8(I)
      KND4(3) = ZWR8(I)
      VOL2(I) = div*VOLTH(KND1, KND2, KND3, KND4)

C     MASSENSCHWERPUNT DES TETRAEDERS BESTIMMEN
      CALL INSPH(KND1,KND2,KND3,KND4,TCENTER,RAD2)
      TC2X = TCENTER(1)
      TC2Y = TCENTER(2)
      TC2Z = TCENTER(3)

C     3. TETRAEDER
C	TETR3 = (1,3,4,8)
      KND1(1) = XWR1(I)
      KND1(2) = YWR1(I)
      KND1(3) = ZWR1(I)
      KND2(1) = XWR3(I)
      KND2(2) = YWR3(I)
      KND2(3) = ZWR3(I)
      KND3(1) = XWR4(I)
      KND3(2) = YWR4(I)
      KND3(3) = ZWR4(I)
      KND4(1) = XWR8(I)
      KND4(2) = YWR8(I)
      KND4(3) = ZWR8(I)
      VOL3(I) = div*VOLTH(KND1, KND2, KND3, KND4)

C     MASSENSCHWERPUNT DES TETRAEDERS BESTIMMEN
      CALL INSPH(KND1,KND2,KND3,KND4,TCENTER,RAD3)
      TC3X = TCENTER(1)
      TC3Y = TCENTER(2)
      TC3Z = TCENTER(3)

C     4. TETRAEDER
C	TETR4 = (3,6,7,8)
      KND1(1) = XWR3(I)
      KND1(2) = YWR3(I)
      KND1(3) = ZWR3(I)
      KND2(1) = XWR6(I)
      KND2(2) = YWR6(I)
      KND2(3) = ZWR6(I)
      KND3(1) = XWR7(I)
      KND3(2) = YWR7(I)
      KND3(3) = ZWR7(I)
      KND4(1) = XWR8(I)
      KND4(2) = YWR8(I)
      KND4(3) = ZWR8(I)
      VOL4(I) = div*VOLTH(KND1, KND2, KND3, KND4)

C     MASSENSCHWERPUNT DES TETRAEDERS BESTIMMEN
      CALL INSPH(KND1,KND2,KND3,KND4,TCENTER,RAD4)
      TC4X = TCENTER(1)
      TC4Y = TCENTER(2)
      TC4Z = TCENTER(3)

C     5. TETRAEDER
C	TETR5 = (1,3,6,8)
      KND1(1) = XWR1(I)
      KND1(2) = YWR1(I)
      KND1(3) = ZWR1(I)
      KND2(1) = XWR3(I)
      KND2(2) = YWR3(I)
      KND2(3) = ZWR3(I)
      KND3(1) = XWR6(I)
      KND3(2) = YWR6(I)
      KND3(3) = ZWR6(I)
      KND4(1) = XWR8(I)
      KND4(2) = YWR8(I)
      KND4(3) = ZWR8(I)
      VOL5(I) = div*VOLTH(KND1, KND2, KND3, KND4)
C     MASSENSCHWERPUNT DES TETRAEDERS BESTIMMEN
      CALL INSPH(KND1,KND2,KND3,KND4,TCENTER,RAD5)
      TC5X = TCENTER(1)
      TC5Y = TCENTER(2)
      TC5Z = TCENTER(3)

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      SVOL2 = VOL1(I)+VOL2(I)+VOL3(I)+VOL4(I)+VOL5(I)
      DIFF = (VOLWR(I)-SVOL2)
      PDIFF = DIFF*100.D0/VOLWR(I)
      
      IF(DBG_WR)THEN      
      WRITE(73,'(E16.2,1X,E16.2,1X,E12.6,1X,F12.6)') 
     & SVOL2, VOLWR(I), DIFF, PDIFF
      ENDIF

      WEIGHT=VOL1(I)+VOL2(I)+VOL3(I)+VOL4(I)+VOL5(I)
C     X,Y,Z-Koordinates of the Center of the Hexhedron
      MCENTER(I,1) =
     & TC1X*(VOL1(I)/WEIGHT)+
     & TC2X*(VOL2(I)/WEIGHT)+
     & TC3X*(VOL3(I)/WEIGHT)+
     & TC4X*(VOL4(I)/WEIGHT)+
     & TC5X*(VOL5(I)/WEIGHT)

      MCENTER(I,2)=
     & TC1Y*(VOL1(I)/WEIGHT)+
     & TC2Y*(VOL2(I)/WEIGHT)+
     & TC3Y*(VOL3(I)/WEIGHT)+
     & TC4Y*(VOL4(I)/WEIGHT)+
     & TC5Y*(VOL5(I)/WEIGHT)

      MCENTER(I,3)=
     & TC1Z*(VOL1(I)/WEIGHT)+
     & TC2Z*(VOL2(I)/WEIGHT)+
     & TC3Z*(VOL3(I)/WEIGHT)+
     & TC4Z*(VOL4(I)/WEIGHT)+
     & TC5Z*(VOL5(I)/WEIGHT)

C      WRITE(72,'(F12.2,1X,F12.2,1X,F12.4,1X,F12.6)') 
C     & TC1X(I),TC1Y(I),TC1Z(I),RAD1
C      WRITE(72,'(F12.2,1X,F12.2,1X,F12.4,1X,F12.6)') 
C     & TC2X(I),TC2Y(I),TC2Z(I),RAD2
C      WRITE(72,'(F12.2,1X,F12.2,1X,F12.4,1X,F12.6)') 
C     & TC3X(I),TC3Y(I),TC3Z(I),RAD3
C      WRITE(72,'(F12.2,1X,F12.2,1X,F12.4,1X,F12.6)') 
C     & TC4X(I),TC4Y(I),TC4Z(I),RAD4
C      WRITE(72,'(F12.2,1X,F12.2,1X,F12.4,1X,F12.6)') 
C     & TC5X(I),TC5Y(I),TC5Z(I),RAD5
C      WRITE(72,'(F12.2,1X,F12.2,1XF12.4)') 
C     & MCENTER(I,1),MCENTER(I,2),MCENTER(I,3)
      
      IF(DBG_WR)THEN
            
      DXSCR1 = DSQRT(
     + (XWR1(I)-XWR2(I))**2+(YWR1(I)-YWR2(I))**2+(ZWR1(I)-ZWR2(I))**2)
      DXSCR2 = DSQRT(
     + (XWR4(I)-XWR3(I))**2+(YWR4(I)-YWR3(I))**2+(ZWR4(I)-ZWR3(I))**2)
      DXSCR3 = DSQRT(
     + (XWR5(I)-XWR6(I))**2+(XWR5(I)-XWR6(I))**2+(XWR5(I)-XWR6(I))**2)
      DXSCR4 = DSQRT(
     + (XWR8(I)-XWR7(I))**2+(YWR8(I)-YWR7(I))**2+(ZWR8(I)-ZWR7(I))**2)
      
      DYSCR1 = DSQRT(
     + (YWR1(I)-YWR4(I))**2+(XWR1(I)-XWR4(I))**2+(ZWR1(I)-ZWR4(I))**2)
      DYSCR2 = DSQRT(
     + (YWR2(I)-YWR3(I))**2+(XWR2(I)-XWR3(I))**2+(ZWR2(I)-ZWR3(I))**2)
      DYSCR3 = DSQRT(
     + (YWR5(I)-YWR8(I))**2+(XWR5(I)-XWR8(I))**2+(ZWR5(I)-ZWR8(I))**2)
      DYSCR4 = DSQRT(
     + (YWR6(I)-YWR7(I))**2+(XWR6(I)-XWR7(I))**2+(ZWR6(I)-ZWR7(I))**2)
      
      DZSCR1 = DSQRT(
     + (ZWR5(I)-ZWR1(I))**2+(XWR5(I)-XWR1(I))**2+(YWR5(I)-YWR1(I))**2)
      DZSCR2 = DSQRT(
     + (ZWR6(I)-ZWR2(I))**2+(XWR6(I)-XWR2(I))**2+(YWR6(I)-YWR2(I))**2)
      DZSCR3 = DSQRT(
     + (ZWR7(I)-ZWR3(I))**2+(XWR7(I)-XWR3(I))**2+(YWR7(I)-YWR3(I))**2)
      DZSCR4 = DSQRT(
     + (ZWR8(I)-ZWR4(I))**2+(XWR8(I)-XWR4(I))**2+(YWR8(I)-YWR4(I))**2)
      
      MSCR(1) = 0.25D0 * (DXSCR1 + DXSCR2 + DXSCR3 + DXSCR4)
      MSCR(2) = 0.25D0 * (DYSCR1 + DYSCR2 + DYSCR3 + DYSCR4)
      MSCR(3) = 0.25D0 * (DZSCR1 + DZSCR2 + DZSCR3 + DZSCR4)

      IF(DBG_WR)THEN            
      WRITE(73,*) I
      WRITE(73,1001) MCENTER(I,1),MCENTER(I,2),MCENTER(I,3)
      WRITE(73,1001) MSCR(1),MSCR(2),MSCR(3)
      WRITE(73,1002) 
     +(MCENTER(I,1)-MSCR(1)),
     +(MCENTER(I,2)-MSCR(2)),
     +(MCENTER(I,3)-MSCR(3))
      ENDIF
      ENDIF      
      ENDDO

      IF(DBG_WR)THEN
1001  FORMAT(3(F12.4,1X))
1002  FORMAT(3(E12.4,1X))
      CLOSE(73)
      ENDIF


      DEALLOCATE(VOL1)
      DEALLOCATE(VOL2)
      DEALLOCATE(VOL3)
      DEALLOCATE(VOL4)
      DEALLOCATE(VOL5)
      
      RETURN
      END      
