C *********************************************************************
C
C     PURPOSE OF THIS SUBROUTINE IS TO CALCULATE THE VOLUME OF THE 
C     CONTROL-VOLUMES.
C     IT IS BASED ON A SUBROUTINE FROM GOUR-TSYH YEH 
C     (COMPUTATIONAL SUBSURFACE HYDROLOGY, FLUID FLOWS, 1999).
C
C *********************************************************************
      SUBROUTINE CALCVOL2()

      USE FEARRAYS

      IMPLICIT NONE 

      INCLUDE 'nogrid.fi'
      INCLUDE 'genrl.inc'
      
      INTEGER          MAXEL, MAXNP, MXLINE, M, N
      PARAMETER(       MAXEL = 1, MAXNP = 8, MXLINE = 1)
      INTEGER          IE(MAXEL,11),IXYZ(MAXNP) 
      DOUBLE PRECISION XWR0(MAXNP),YWR0(MAXNP),ZWR0(MAXNP)
      DOUBLE PRECISION XWRK(MXLINE)
      DOUBLE PRECISION SVOL
      LOGICAL          READDATA
      DOUBLE PRECISION ESTVOL,MAXX,MINX,MAXY,MINY,MEANZ1,MEANZ2
      
      IF(LINFO.GT.2) WRITE(*,*) 'NRELEMENTS', NRELEMENTS, NE
      
C *********************************************************************
C     DIE KNOTEN-NUMMERIERUNG IST CCW VON UNTEN NACH OBEN (Z ZUNEHMEND)
C     Am Punkt (0,0,0) ist der erste Knoten, an (1,0,0) der zweite, ...
C     am Punkt (0,0,1) ist der fuenfte Knoten, an (1,0,1) der sechste, ...
C
C *********************************************************************
      M = 1
      N = 0
      DO I = 1, MAXEL
	    DO J =1, 11
      N = N +1
	    IE(I,J) = N
	    ENDDO
      ENDDO
      IF(LINFO.GT.2) WRITE(*,*)   MAXNP,MAXEL,MXLINE,M
      DO I = 1, MAXEL
C      WRITE(*,'(11(I6,1X))') (IE(MAXEL,J), J=1, 11)
      ENDDO

      DO I =1, MAXNP
      IXYZ(I)  = 0
C      WRITE(*,*) IXYZ(I) 
      ENDDO
C
      DO I = 1, MXLINE
      XWRK(I) = 0
C      WRITE(*,*) XWRK(I)
      ENDDO

C      WRITE(*,'(8(E10.2,1X,E10.2,1X,E10.2,1X))') 
C     & X1(I),Y1(I),Z1(I),X2(I),Y2(I),Z2(I),X3(I),Y3(I),Z3(I),
C     & X4(I),Y4(I),Z4(I),X5(I),Y5(I),Z5(I),X6(I),Y6(I),Z6(I),
C     & X7(I),Y7(I),Z7(I),X8(I),Y8(I),Z8(I)

      IF(DBG_WR)THEN
      CLOSE(74)
      CLOSE(75)
      OPEN(74,FILE='volume-1.dat')
      OPEN(75,FILE='volume-2.dat')
      ENDIF
      
      DO I = 1, NE

      XWR0(1) = XWR1(I)
      YWR0(1) = YWR1(I)
      ZWR0(1) = ZWR1(I)
      XWR0(2) = XWR2(I)
      YWR0(2) = YWR2(I)
      ZWR0(2) = ZWR2(I)
      XWR0(3) = XWR3(I)
      YWR0(3) = YWR3(I)
      ZWR0(3) = ZWR3(I)
      XWR0(4) = XWR4(I)
      YWR0(4) = YWR4(I)
      ZWR0(4) = ZWR4(I)
      XWR0(5) = XWR5(I)
      YWR0(5) = YWR5(I)
      ZWR0(5) = ZWR5(I)
      XWR0(6) = XWR6(I)
      YWR0(6) = YWR6(I)
      ZWR0(6) = ZWR6(I)
      XWR0(7) = XWR7(I)
      YWR0(7) = YWR7(I)
      ZWR0(7) = ZWR7(I)
      XWR0(8) = XWR8(I)
      YWR0(8) = YWR8(I)
      ZWR0(8) = ZWR8(I)
      
C      WRITE(*,*) '3',MAXNP,MAXEL,MXLINE

      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR0,YWR0,ZWR0,XWRK,IE,IXYZ,M,SVOL)

      J = 0
      
      IF(DBG_WR)THEN
      WRITE(75,'(E12.6,1X,8(F10.2,1X,F10.2,1X,F10.4,1X))') 
     & SVOL, (XWR0(J),YWR0(J),ZWR0(J), J=1, 8)
      ENDIF
       
      MINX = +1.D64
      MINY = +1.D54
      MAXX = -1.D64
      MAXY = -1.D64

      DO J = 1, 8
      MINX = MIN(XWR0(J),MINX)
      MINY = MIN(YWR0(J),MINY)
      MAXX = MAX(XWR0(J),MAXX)
      MAXY = MAX(YWR0(J),MAXY)
      ENDDO

      MEANZ1 = (ZWR0(1)+ZWR0(2)+ZWR0(3)+ZWR0(4))/4.D0
      MEANZ2 = (ZWR0(5)+ZWR0(6)+ZWR0(7)+ZWR0(8))/8.D0
      ESTVOL = (MAXX-MINX)*(MAXY-MINY)*ABS(MEANZ1-MEANZ2)
      
      IF(DBG_WR)THEN
      WRITE(74,'(E12.6,1X,E12.6)')    SVOL , ESTVOL
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(1),YWR0(1),ZWR0(1)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(2),YWR0(2),ZWR0(2)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(3),YWR0(3),ZWR0(3)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(4),YWR0(4),ZWR0(4)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(5),YWR0(5),ZWR0(5)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(6),YWR0(6),ZWR0(6)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(7),YWR0(7),ZWR0(7)
      WRITE(74,'(F10.2,1X,F10.2,1X,F10.4)')XWR0(8),YWR0(8),ZWR0(8)
      ENDIF
      
      VOLWR(I) = SVOL

      ENDDO
      
      IF(DBG_WR)THEN
      CLOSE(74)
      CLOSE(75)
      ENDIF
      
      RETURN      
      END
