C *********************************************************************
C
C     PURPOSE OF THIS SUBROUTINE IS TO CALCULATE THE VOLUME OF THE 
C     CONTROL-VOLUMES.
C     IT IS BASED ON A SUBROUTINE FROM GOUR-TSYH YEH 
C     (COMPUTATIONAL SUBSURFACE HYDROLOGY, FLUID FLOWS, 1999).
C
C *********************************************************************
      SUBROUTINE CALCVOL3()
      
      include 'felder.inc'
      USE NO
      
      IMPLICIT NONE 
      
      include 'genrl.inc'
      include 'genrlc.inc'

      INTEGER          MAXEL, MAXNP, MXLINE, M, N
      PARAMETER(       MAXEL = 1, MAXNP = 8, MXLINE = 1)
      INTEGER          IE(MAXEL,11),IXYZ(MAXNP) 

      DOUBLE PRECISION XWR2(MAXNP),YWR2(MAXNP),ZWR2(MAXNP),XWRK(MXLINE)
      DOUBLE PRECISION SVOL
      LOGICAL READDATA
      DOUBLE PRECISION ESTVOL,MAXX,MINX,MAXY,MINY,MEANZ1,MEANZ2
      DOUBLE PRECISION MINVP,MAXVP
      INTEGER          IVPMAX,JVPMAX,KVPMAX,IVPMIN,JVPMIN,KVPMIN
      DOUBLE PRECISION MYVOL,MYCENTER(3)

      CLOSE(87)
      OPEN(87,FILE='centerdiff.dat')

      CLOSE(88)
      OPEN(88,FILE='volumes.dat')
      
      MINVP = 1.D+64
      MAXVP = 0.D0
C *********************************************************************
C     DIE KNOTEN-NUMMERIERUNG IST CCW VON UNTEN NACH OBEN (Z ZUNEHMEND)
C     Am Punkt (0,0,0) ist der erste Knoten, an (1,0,0) der zweite, ...
C     am Punkt (0,0,1) ist der fuenfte Knoten, an (1,0,1) der sechste, ...
C
C *********************************************************************
      M = 1
      N = 0
      DO I = 1, MAXEL
          DO J =1, 11
          N = N +1
          IE(I,J) = N
          ENDDO
      ENDDO
      IF(LINFO.GT.2) WRITE(*,*)   MAXNP,MAXEL,MXLINE,M
      DO I = 1, MAXEL
      ENDDO

      DO I =1, MAXNP
      IXYZ(I)  = 0
      ENDDO
      
      DO I = 1, MXLINE
      XWRK(I) = 0
      ENDDO

      DO K = 1, K0
      DO J = 1, J0
      DO I = 1, I0
      XWR2(1) =XXI(I,J,K,1) 
      YWR2(1) =YYI(I,J,K,1) 
      ZWR2(1) =ZZI(I,J,K,1) 
      XWR2(2) =XXI(I,J,K,2) 
      YWR2(2) =YYI(I,J,K,2) 
      ZWR2(2) =ZZI(I,J,K,2) 
      XWR2(3) =XXI(I,J,K,3) 
      YWR2(3) =YYI(I,J,K,3) 
      ZWR2(3) =ZZI(I,J,K,3) 
      XWR2(4) =XXI(I,J,K,4) 
      YWR2(4) =YYI(I,J,K,4) 
      ZWR2(4) =ZZI(I,J,K,4) 
      XWR2(5) =XXI(I,J,K,5) 
      YWR2(5) =YYI(I,J,K,5) 
      ZWR2(5) =ZZI(I,J,K,5) 
      XWR2(6) =XXI(I,J,K,6)
      YWR2(6) =YYI(I,J,K,6) 
      ZWR2(6) =ZZI(I,J,K,6) 
      XWR2(7) =XXI(I,J,K,7) 
      YWR2(7) =YYI(I,J,K,7) 
      ZWR2(7) =ZZI(I,J,K,7) 
      XWR2(8) =XXI(I,J,K,8) 
      YWR2(8) =YYI(I,J,K,8) 
      ZWR2(8) =ZZI(I,J,K,8) 
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VP(I,J,K) = SVOL
      
C **********************************************************************
C NEW IMPLEMENTATION (LGPL), WR, 060501
      CALL CALCVOLUME(XWR2,YWR2,ZWR2,MYVOL,MYCENTER)
      
      WRITE(87,'(3I4,4(1X,E20.10))') I,J,K,
     + (CENTER(I,J,K,1)-MYCENTER(1)),
     + (CENTER(I,J,K,2)-MYCENTER(2)),
     + (CENTER(I,J,K,3)-MYCENTER(3)),(VP(I,J,K)-MYVOL)      
      
      VP(I,J,K) = MYVOL
                  
      CENTER(I,J,K,1)= MYCENTER(1)
      CENTER(I,J,K,2)= MYCENTER(2)
      CENTER(I,J,K,3)= MYCENTER(3)
C **********************************************************************
      
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
!    1: ne (1,1)  2: se (1,2)  3: sw (1,3)  4: nw (1,4)  
!    5: te (2,1)  6: ts (2,2)  7: tw (2,3)  8: tn (2,4)  
!    9: be (3,1) 10: bs (3,2) 11: bw (3,3) 12: bn (3,4)
!   13:  E (4,1) 14:  S (4,2) 15:  W (4,3) 16:  N (4,4)  
!   17: T (5,1)  18: B(5,2)   19: P(5,3)

!   OESTLICHES VOLUMEN (IMMER CCW):
!   bs(I,J,K),bn(I,J,K),bn(I+1,J,K),bs(I+1,J,K),ts(I,J,K),tn(I,J,K),tn(I+1,J,K),ts(I+1,J,K)
!   10(I,J,K,3,2) | 12(I,J,K,3,4) | 12(I+1,J,K,3,4) | 10(I+1,J,K,3,2) 
!    6(I,J,K,2,2) |  8(I,J,K,2,4) |  8(I+1,J,K,2,4) |  6(I+1,J,K,2,2) 
!
!      
!   DIE VARIABLEN X,Y,ZWR-ZAHL-(I,J,K,8) ENTHALTEN DIE INFORMATION 
!   UEBER DIE MITTELPUNKTE DER KANTEN DES CV !
!
      IF(I.LT.I0)THEN
      XWR2(1) =XCI(I,J,K,3,2) 
      YWR2(1) =YCI(I,J,K,3,2) 
      ZWR2(1) =ZCI(I,J,K,3,2) 
      XWR2(2) =XCI(I,J,K,3,4) 
      YWR2(2) =YCI(I,J,K,3,4) 
      ZWR2(2) =ZCI(I,J,K,3,4) 
      XWR2(3) =XCI(I+1,J,K,3,4) 
      YWR2(3) =YCI(I+1,J,K,3,4) 
      ZWR2(3) =ZCI(I+1,J,K,3,4) 
      XWR2(4) =XCI(I+1,J,K,3,2) 
      YWR2(4) =YCI(I+1,J,K,3,2) 
      ZWR2(4) =ZCI(I+1,J,K,3,2) 
      XWR2(5) =XCI(I,J,K,2,2) 
      YWR2(5) =YCI(I,J,K,2,2) 
      ZWR2(5) =ZCI(I,J,K,2,2) 
      XWR2(6) =XCI(I,J,K,2,4)
      YWR2(6) =YCI(I,J,K,2,4) 
      ZWR2(6) =ZCI(I,J,K,2,4) 
      XWR2(7) =XCI(I+1,J,K,2,4) 
      YWR2(7) =YCI(I+1,J,K,2,4) 
      ZWR2(7) =ZCI(I+1,J,K,2,4) 
      XWR2(8) =XCI(I+1,J,K,2,2) 
      YWR2(8) =YCI(I+1,J,K,2,2) 
      ZWR2(8) =ZCI(I+1,J,K,2,2) 
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VE(I,J,K) = SVOL
      ENDIF
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
!    1: ne (1,1)  2: se (1,2)  3: sw (1,3)  4: nw (1,4)  
!    5: te (2,1)  6: ts (2,2)  7: tw (2,3)  8: tn (2,4)  
!    9: be (3,1) 10: bs (3,2) 11: bw (3,3) 12: bn (3,4)
!   13:  E (4,1) 14:  S (4,2) 15:  W (4,3) 16:  N (4,4)  
!   17: T (5,1)  18: B(5,2)   19: P(5,3)

!   SUEDLICHES VOLUMEN (IMMER CCW):
!   bw(I,J,K),be(I,J,K),be(I,J-1,K),bw(I,J-1,K),tw(I,J,K),te(I,J,K),te(I,J-1,K),tw(I,J-1,K)
!   11(I,J,K,3,3) | 9(I,J,K,3,1) | 9(I,J-1,K,3,1) | 11(I,J-1,K,3,3) 
!    7(I,J,K,2,3) | 5(I,J,K,2,1) | 5(I,J-1,K,2,1) |  7(I,J-1,K,2,3) 
!
      IF(J.GT.1)THEN
      XWR2(1) =XCI(I,J,K,3,3) 
      YWR2(1) =YCI(I,J,K,3,3) 
      ZWR2(1) =ZCI(I,J,K,3,3) 
      XWR2(2) =XCI(I,J,K,3,1) 
      YWR2(2) =YCI(I,J,K,3,1) 
      ZWR2(2) =ZCI(I,J,K,3,1) 
      XWR2(3) =XCI(I,J-1,K,3,1) 
      YWR2(3) =YCI(I,J-1,K,3,1) 
      ZWR2(3) =ZCI(I,J-1,K,3,1) 
      XWR2(4) =XCI(I,J-1,K,3,3) 
      YWR2(4) =YCI(I,J-1,K,3,3) 
      ZWR2(4) =ZCI(I,J-1,K,3,3) 
      XWR2(5) =XCI(I,J,K,2,3) 
      YWR2(5) =YCI(I,J,K,2,3) 
      ZWR2(5) =ZCI(I,J,K,2,3) 
      XWR2(6) =XCI(I,J,K,2,1)
      YWR2(6) =YCI(I,J,K,2,1) 
      ZWR2(6) =ZCI(I,J,K,2,1) 
      XWR2(7) =XCI(I,J-1,K,2,1) 
      YWR2(7) =YCI(I,J-1,K,2,1) 
      ZWR2(7) =ZCI(I,J-1,K,2,1) 
      XWR2(8) =XCI(I,J-1,K,2,3) 
      YWR2(8) =YCI(I,J-1,K,2,3) 
      ZWR2(8) =ZCI(I,J-1,K,2,3)
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VS(I,J,K) = SVOL
      ENDIF
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
!   WESTLICHES VOLUMEN (IMMER CCW):
!   WIE OSTEN NUR I-INDEX ANDERS HERUM !
      IF(I.GT.1)THEN
      XWR2(1) =XCI(I-1,J,K,3,2) 
      YWR2(1) =YCI(I-1,J,K,3,2) 
      ZWR2(1) =ZCI(I-1,J,K,3,2) 
      XWR2(2) =XCI(I-1,J,K,3,4) 
      YWR2(2) =YCI(I-1,J,K,3,4) 
      ZWR2(2) =ZCI(I-1,J,K,3,4) 
      XWR2(3) =XCI(I,J,K,3,4) 
      YWR2(3) =YCI(I,J,K,3,4) 
      ZWR2(3) =ZCI(I,J,K,3,4) 
      XWR2(4) =XCI(I,J,K,3,2) 
      YWR2(4) =YCI(I,J,K,3,2) 
      ZWR2(4) =ZCI(I,J,K,3,2) 
      XWR2(5) =XCI(I-1,J,K,2,2) 
      YWR2(5) =YCI(I-1,J,K,2,2) 
      ZWR2(5) =ZCI(I-1,J,K,2,2) 
      XWR2(6) =XCI(I-1,J,K,2,4)
      YWR2(6) =YCI(I-1,J,K,2,4) 
      ZWR2(6) =ZCI(I-1,J,K,2,4) 
      XWR2(7) =XCI(I,J,K,2,4) 
      YWR2(7) =YCI(I,J,K,2,4) 
      ZWR2(7) =ZCI(I,J,K,2,4) 
      XWR2(8) =XCI(I,J,K,2,2) 
      YWR2(8) =YCI(I,J,K,2,2) 
      ZWR2(8) =ZCI(I,J,K,2,2) 
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VW(I,J,K) = SVOL
      ENDIF
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                  
!   NOERDLICHES VOLUMEN (IMMER CCW):
!   WIE SUEDLICHES NUR J-INDEX ANDERS HERUM
      IF(J.LT.J0)THEN
      XWR2(1) =XCI(I,J+1,K,3,3) 
      YWR2(1) =YCI(I,J+1,K,3,3) 
      ZWR2(1) =ZCI(I,J+1,K,3,3) 
      XWR2(2) =XCI(I,J+1,K,3,1) 
      YWR2(2) =YCI(I,J+1,K,3,1) 
      ZWR2(2) =ZCI(I,J+1,K,3,1) 
      XWR2(3) =XCI(I,J,K,3,1) 
      YWR2(3) =YCI(I,J,K,3,1) 
      ZWR2(3) =ZCI(I,J,K,3,1) 
      XWR2(4) =XCI(I,J,K,3,3) 
      YWR2(4) =YCI(I,J,K,3,3) 
      ZWR2(4) =ZCI(I,J,K,3,3) 
      XWR2(5) =XCI(I,J+1,K,2,3) 
      YWR2(5) =YCI(I,J+1,K,2,3) 
      ZWR2(5) =ZCI(I,J+1,K,2,3) 
      XWR2(6) =XCI(I,J+1,K,2,1)
      YWR2(6) =YCI(I,J+1,K,2,1) 
      ZWR2(6) =ZCI(I,J+1,K,2,1) 
      XWR2(7) =XCI(I,J,K,2,1) 
      YWR2(7) =YCI(I,J,K,2,1) 
      ZWR2(7) =ZCI(I,J,K,2,1) 
      XWR2(8) =XCI(I,J,K,2,3) 
      YWR2(8) =YCI(I,J,K,2,3) 
      ZWR2(8) =ZCI(I,J,K,2,3)
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VN(I,J,K) = SVOL
      ENDIF
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!   TOP (OBERES) VOLUMEN (IMMER CCW):
!    1: ne (1,1)  2: se (1,2)  3: sw (1,3)  4: nw (1,4)  
!    5: te (2,1)  6: ts (2,2)  7: tw (2,3)  8: tn (2,4)  
!    9: be (3,1) 10: bs (3,2) 11: bw (3,3) 12: bn (3,4)
!   13:  E (4,1) 14:  S (4,2) 15:  W (4,3) 16:  N (4,4)  
!   17: T (5,1)  18: B(5,2)   19: P(5,3)
!
!   sw(I,J,K),nw(I,J,K),ne(I,J,K),se(I,J,K),sw(I,J,K+1),nw(I,J,K+1),ne(I,J,K+1),se(I,J,K+1)
!   3(I,J,K,1,3)   | 4(I,J,K,1,4)   | 1(I,J,K,1,1)   | 2(I,J,K,1,2) 
!   3(I,J,K+1,1,3) | 4(I,J,K+1,1,4) | 1(I,J,K+1,1,1) | 2(I,J,K+1,1,2) 
!
      IF(K.LT.K0)THEN
      XWR2(1) =XCI(I,J,K,1,3)
      YWR2(1) =YCI(I,J,K,1,3)
      ZWR2(1) =ZCI(I,J,K,1,3)
      XWR2(2) =XCI(I,J,K,1,4)
      YWR2(2) =YCI(I,J,K,1,4)
      ZWR2(2) =ZCI(I,J,K,1,4)
      XWR2(3) =XCI(I,J,K,1,1)
      YWR2(3) =YCI(I,J,K,1,1)
      ZWR2(3) =ZCI(I,J,K,1,1)
      XWR2(4) =XCI(I,J,K,1,2)
      YWR2(4) =YCI(I,J,K,1,2)
      ZWR2(4) =ZCI(I,J,K,1,2)
      XWR2(5) =XCI(I,J,K+1,1,3)
      YWR2(5) =YCI(I,J,K+1,1,3)
      ZWR2(5) =ZCI(I,J,K+1,1,3)
      XWR2(6) =XCI(I,J,K+1,1,4)
      YWR2(6) =YCI(I,J,K+1,1,4)
      ZWR2(6) =ZCI(I,J,K+1,1,4)
      XWR2(7) =XCI(I,J,K+1,1,1)
      YWR2(7) =YCI(I,J,K+1,1,1)
      ZWR2(7) =ZCI(I,J,K+1,1,1)
      XWR2(8) =XCI(I,J,K+1,1,2)
      YWR2(8) =YCI(I,J,K+1,1,2)
      ZWR2(8) =ZCI(I,J,K+1,1,2)
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VT(I,J,K) = SVOL
      ENDIF
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!   BOTTOM (UNTERES) VOLUMEN (IMMER CCW):
!   WIE TOP, NUR INDEX ANDERS HERUM
      IF(K.GT.1)THEN
      XWR2(1) =XCI(I,J,K-1,1,3)
      YWR2(1) =YCI(I,J,K-1,1,3)
      ZWR2(1) =ZCI(I,J,K-1,1,3)
      XWR2(2) =XCI(I,J,K-1,1,4)
      YWR2(2) =YCI(I,J,K-1,1,4)
      ZWR2(2) =ZCI(I,J,K-1,1,4)
      XWR2(3) =XCI(I,J,K-1,1,1)
      YWR2(3) =YCI(I,J,K-1,1,1)
      ZWR2(3) =ZCI(I,J,K-1,1,1)
      XWR2(4) =XCI(I,J,K-1,1,2)
      YWR2(4) =YCI(I,J,K-1,1,2)
      ZWR2(4) =ZCI(I,J,K-1,1,2)
      XWR2(5) =XCI(I,J,K,1,3)
      YWR2(5) =YCI(I,J,K,1,3)
      ZWR2(5) =ZCI(I,J,K,1,3)
      XWR2(6) =XCI(I,J,K,1,4)
      YWR2(6) =YCI(I,J,K,1,4)
      ZWR2(6) =ZCI(I,J,K,1,4)
      XWR2(7) =XCI(I,J,K,1,1)
      YWR2(7) =YCI(I,J,K,1,1)
      ZWR2(7) =ZCI(I,J,K,1,1)
      XWR2(8) =XCI(I,J,K,1,2)
      YWR2(8) =YCI(I,J,K,1,2)
      ZWR2(8) =ZCI(I,J,K,1,2)
      
      CALL VOLUME(
     & MAXNP,MAXEL,MXLINE,XWR2,YWR2,ZWR2,XWRK,IE,IXYZ,M,SVOL)
      VB(I,J,K) = SVOL
      ENDIF
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C   SOLLTE ES HIER BESSER HEISSEN, BSPW::
C   IF(I.EQ.I0) VE(I,J,K) = VW(I,J,K) ????????????????????
C   
      IF(I.EQ.I0) VE(I,J,K) = VP(I,J,K)
      IF(I.EQ.1)  VW(I,J,K) = VP(I,J,K)
      IF(J.EQ.J0) VN(I,J,K) = VP(I,J,K)
      IF(J.EQ.1)  VS(I,J,K) = VP(I,J,K)
      IF(K.EQ.K0) VT(I,J,K) = VP(I,J,K)
      IF(K.EQ.1)  VB(I,J,K) = VP(I,J,K)
      
!       MEANZ1 = (Z(1)+Z(2)+Z(3)+Z(4))/4.D0
!       MEANZ2 = (Z(5)+Z(6)+Z(7)+Z(8))/8.D0
!       ESTVOL = (MAXX-MINX)*(MAXY-MINY)*ABS(MEANZ1-MEANZ2)
      IF(VP(I,J,K).LE.0.D0.OR.VE(I,J,K).LE.0.D0.OR.
     +   VS(I,J,K).LE.0.D0.OR.VW(I,J,K).LE.0.D0.OR.
     +   VN(I,J,K).LE.0.D0.OR.VT(I,J,K).LE.0.D0.OR.
     +   VB(I,J,K).LE.0.D0)THEN
      WRITE(*,*) 'VOLUME LOWER THAN ZERO !!!',
     +VP(I,J,K),VE(I,J,K),VS(I,J,K),
     +VW(I,J,K),VN(I,J,K),VT(I,J,K),VB(I,J,K)
      WRITE(*,*) I,J,K
      STOP
      ENDIF
      
      IF(VP(I,J,K).GT.MAXVP)THEN
      MAXVP = VP(I,J,K)
      IVPMAX = I
      JVPMAX = J
      KVPMAX = K
      ENDIF
      IF(VP(I,J,K).LT.MINVP)THEN
      MINVP = VP(I,J,K)
      IVPMIN = I
      JVPMIN = J
      KVPMIN = K
      ENDIF

      WRITE(88,'(3I4,7(1X,E16.6)))') I,J,K,
     + VP(I,J,K),
     + VN(I,J,K),VS(I,J,K),VE(I,J,K),VW(I,J,K),VT(I,J,K),VB(I,J,K)
      
      ENDDO
      ENDDO
      ENDDO
      IF(LINFO.GE.2)THEN
      WRITE(*,100)
     + 'MAXIMUM VOLUME = ',MAXVP
      WRITE(*,101) 'AT: ',IVPMAX,JVPMAX,KVPMAX
      WRITE(*,'(3(F14.4,1X))') 
     + CENTER(IVPMAX,JVPMAX,KVPMAX,1),
     + CENTER(IVPMAX,JVPMAX,KVPMAX,2),
     + CENTER(IVPMAX,JVPMAX,KVPMAX,3)
      WRITE(*,100) 'MINIMUM VOLUME = ',MINVP
      WRITE(*,101) 'AT: ',IVPMIN,JVPMIN,KVPMIN
      WRITE(*,'(3(F14.4,1X))') 
     + CENTER(IVPMIN,JVPMIN,KVPMIN,1),
     + CENTER(IVPMIN,JVPMIN,KVPMIN,2),
     + CENTER(IVPMIN,JVPMIN,KVPMIN,3)

100   FORMAT(A17,1X,E20.6)
101   FORMAT(A4,3(1X,I5))
      ENDIF
      CLOSE(87)
      CLOSE(88)      
      RETURN      
      END
