C
C 
C @author Wolfram Ruehaak
C @return hexaeder center of gravity and volume
C @version 0.1
C
C license LGPL
C date 06/03/22
C
C

      SUBROUTINE CALCVOLUME(XH,YH,ZH,
     +                       HVOLUME,HCENTER)
      
      IMPLICIT NONE

      DOUBLE PRECISION HVOLUME,SCR
      DOUBLE PRECISION HCENTER(3)
      DOUBLE PRECISION XH(8)
      DOUBLE PRECISION YH(8)
      DOUBLE PRECISION ZH(8)		
      DOUBLE PRECISION XT(4)
      DOUBLE PRECISION YT(4)
      DOUBLE PRECISION ZT(4)
      DOUBLE PRECISION TVOLUME(12)
      DOUBLE PRECISION TCENTER(12,3)
      DOUBLE PRECISION TETRAVOLUME
      DOUBLE PRECISION CENTER(3),TETRAEDER(3,12,4)
      INTEGER T, L, C
      
      CALL HEX2TET(XH,YH,ZH,TETRAEDER)									
   
      DO T = 1, 12
         DO L = 1, 4
         XT(L) = TETRAEDER(1,T,L)
         YT(L) = TETRAEDER(2,T,L)
         ZT(L) = TETRAEDER(3,T,L)
         ENDDO
      TVOLUME(T) = TETRAVOLUME(XT,YT,ZT)
      CALL TETRACENTER(XT,YT,ZT,CENTER)
      TCENTER(T,1) = CENTER(1)
      TCENTER(T,2) = CENTER(2)
      TCENTER(T,3) = CENTER(3)
      ENDDO
      
      HVOLUME = 	TVOLUME(1)+TVOLUME(2)+TVOLUME(3)+TVOLUME(4)+
     + 	                TVOLUME(5)+TVOLUME(6)+TVOLUME(7)+TVOLUME(8)+
     +           	TVOLUME(9)+TVOLUME(10)+TVOLUME(11)+TVOLUME(12)
			
      DO C = 1, 3
      HCENTER(C) = 	
     +      (TCENTER(1,C)*TVOLUME(1)+TCENTER(2,C)*TVOLUME(2)+
     +      TCENTER(3,C)*TVOLUME(3)+TCENTER(4,C)*TVOLUME(4)+            
     +      TCENTER(5,C)*TVOLUME(5)+TCENTER(6,C)*TVOLUME(6)+
     +      TCENTER(7,C)*TVOLUME(7)+TCENTER(8,C)*TVOLUME(8)+
     +      TCENTER(9,C)*TVOLUME(9)+TCENTER(10,C)*TVOLUME(10)+
     +      TCENTER(11,C)*TVOLUME(11)+TCENTER(12,C)*TVOLUME(12))/
     +      HVOLUME

      SCR = 	
     +      (TCENTER(1,C)+TCENTER(2,C)+
     +      TCENTER(3,C)+TCENTER(4,C)+            
     +      TCENTER(5,C)+TCENTER(6,C)+
     +      TCENTER(7,C)+TCENTER(8,C)+
     +      TCENTER(9,C)+TCENTER(10,C)+
     +      TCENTER(11,C)+TCENTER(12,C))/
     +      12.D0
!       WRITE(*,'(I4,1X,F12.6,1X,F12.6)') C,SCR,HCENTER(C)
      ENDDO
	
      RETURN
      END
