C
C  
C author Wolfram Ruehaak
C LGPL license
C Calculate the volume of a tetrahedron
C Calculation is based on Bowyer & Woodmark, A programmer's geometry, 1983, p. 118 ff.
C 
C

      DOUBLE PRECISION FUNCTION TETRAVOLUME(X,Y,Z)
      
      IMPLICIT NONE

      DOUBLE PRECISION X(4),Y(4),Z(4)
      DOUBLE PRECISION XLK,YLK,ZLK,XMK,YMK,ZMK,XNK,YNK,ZNK,DMN,DLN,DLM
	
      XLK = X(2) - X(1)
      YLK = Y(2) - Y(1)
      ZLK = Z(2) - Z(1)

      XMK = X(3) - X(1)
      YMK = Y(3) - Y(1)
      ZMK = Z(3) - Z(1)

      XNK = X(4) - X(1)
      YNK = Y(4) - Y(1)
      ZNK = Z(4) - Z(1)
		
      DMN = YMK*ZNK - ZMK*YNK
      DLN = YLK*ZNK - ZLK*YNK
      DLM = YLK*ZMK - ZLK*YMK
		
      TETRAVOLUME = ABS(1.D0/6.D0 * (XLK*DMN - XMK*DLN + XNK*DLM))
      
      RETURN
      END
      