C *********************************************************************
C     BY W. RUEHAAK, LGPL, LICENSE, 2006
C    1. CALCULATE THE AREA OF A TRIANGLE IN IR3
C        BASED ON Bowyer & Woodmark, A programmer's geometry, 1983
C
C    2. CALCULATE THE VECTOR PERPENDICULAR TO THE AREA
C
C *********************************************************************
      SUBROUTINE NEWTAREA(X,Y,Z,AREA,CV)

      IMPLICIT NONE

      DOUBLE PRECISION AREA,X(3),Y(3),Z(3)
      DOUBLE PRECISION AV(3),BV(3),CV(3)


      AREA = 0.5D0*SQRT(
     +((Y(1)-Y(2))*(Z(3)-Z(2)) - (Z(1)-Z(2))*(Y(3)-Y(2)))**2.D0 +
     +((Z(1)-Z(2))*(X(3)-X(2)) - (X(1)-X(2))*(Z(3)-Z(2)))**2.D0 +
     +((X(1)-X(2))*(Y(3)-Y(2)) - (Y(1)-Y(2))*(X(3)-X(2)))**2.D0)

      AV(1) = X(1) - X(3)
      AV(2) = Y(1) - Y(3)
      AV(3) = Z(1) - Z(3)

      BV(1) = X(1) - X(2)
      BV(2) = Y(1) - Y(2)
      BV(3) = Z(1) - Z(2)

      CALL CROSSPROD(AV,BV,CV)
C WR: CV IS THE VECTOR PERPENDICULAR TO THE PLANE DESCRIBED BY AV AND BV

      RETURN
      END
