C *********************************************************************
C     WOLFRAM RUEHAAK, 2004 - 2006
C     IN DIESER SUBROUTINE WIRD DEN ELEMENTEN WIEDER EINE 
C     3D-INDIZIERUNG (I,J,K) ZUGEWIESEN, ANSTATT DER 
C     ELEMENT-INDIZIERUNG.
C     * GETS:     ELEMENT INDICES (I=1,NE) VOLUME COORDINATES 
C                       (KNODES,VERTICES,EDGES, CELLFACES)
C     * RETURNS:  3D-INDICES VOLUME COORDINATES (I,J,K)
C *********************************************************************
      SUBROUTINE REINDEX()
      
      USE FELDER
      USE NO
      USE FEARRAYS
      IMPLICIT NONE

      include 'genrl.inc'
      include 'genrlc.inc'
      INCLUDE 'nogrid.fi'
      
      INTEGER  II,IP2,JP2,KP2
      
C *********************************************************************
C     NORMALE (3D) INDIZIERUNG ZUWEISEN
C**********************************************************************
      IF(REGULAR)THEN
      
      IF(DBG_WR)THEN
      CLOSE(97)
      OPEN(97,FILE='reindex.out')
      ENDIF
      II = 0
C     IMMER ERST I, DANN J, DANN K !!!
      DO K = 1, K0
         DO J = 1, J0
            DO I = 1, I0
      
            II = II + 1       
C
C      DIE 8 ECKEN (KNODES) DES ELEMENTS/CONTROL-VOLUMES
C            
            XXI(I,J,K,1) = XWR1(II)
            YYI(I,J,K,1) = YWR1(II)
            ZZI(I,J,K,1) = ZWR1(II)
            XXI(I,J,K,2) = XWR2(II)
            YYI(I,J,K,2) = YWR2(II)
            ZZI(I,J,K,2) = ZWR2(II)
            XXI(I,J,K,3) = XWR3(II)
            YYI(I,J,K,3) = YWR3(II)
            ZZI(I,J,K,3) = ZWR3(II)
            XXI(I,J,K,4) = XWR4(II)
            YYI(I,J,K,4) = YWR4(II)
            ZZI(I,J,K,4) = ZWR4(II)
            XXI(I,J,K,5) = XWR5(II)
            YYI(I,J,K,5) = YWR5(II)
            ZZI(I,J,K,5) = ZWR5(II)
            XXI(I,J,K,6) = XWR6(II)
            YYI(I,J,K,6) = YWR6(II)
            ZZI(I,J,K,6) = ZWR6(II)
            XXI(I,J,K,7) = XWR7(II)
            YYI(I,J,K,7) = YWR7(II)
            ZZI(I,J,K,7) = ZWR7(II)
            XXI(I,J,K,8) = XWR8(II)
            YYI(I,J,K,8) = YWR8(II)
            ZZI(I,J,K,8) = ZWR8(II)
            MATXYZ(I,J,K) = MAT(II)
C Hier muessen jetzt auch noch die Volumina und Mittelpunkte 
C neu indiziert werden:
C CENTER IST EIN VEKTOR            
            CENTER(I,J,K,1)= MCENTER(II,1)
            CENTER(I,J,K,2)= MCENTER(II,2)
            CENTER(I,J,K,3)= MCENTER(II,3)
C (CONTROL) VOLUME IST EIN SKALAR
            CV(I,J,K)    = VOLWR(II)
C *********************************************************************            
C
C      DIE MITTELPUNKTE DER KANTEN DES ELEMENTS/CONTROL-VOLUMES
C            
         XCI(I,J,K,1,1) = XWR(II,1,1) ! 1: ne
         XCI(I,J,K,1,2) = XWR(II,1,2) ! 2: se
         XCI(I,J,K,1,3) = XWR(II,1,3) ! 3: sw
         XCI(I,J,K,1,4) = XWR(II,1,4) ! 4: nw
         XCI(I,J,K,2,1) = XWR(II,2,1) ! 5: te
         XCI(I,J,K,2,2) = XWR(II,2,2) ! 6: ts
         XCI(I,J,K,2,3) = XWR(II,2,3) ! 7: tw
         XCI(I,J,K,2,4) = XWR(II,2,4) ! 8: tn
         XCI(I,J,K,3,1) = XWR(II,3,1) ! 9: be
         XCI(I,J,K,3,2) = XWR(II,3,2) ! 10: bs
         XCI(I,J,K,3,3) = XWR(II,3,3) ! 11: bw
         XCI(I,J,K,3,4) = XWR(II,3,4) ! 12: bn
!          XCI(I,J,K,4,1) = XWR(II,4,1) ! 13: E
!          XCI(I,J,K,4,2) = XWR(II,4,2) ! 14: S
!          XCI(I,J,K,4,3) = XWR(II,4,3) ! 15: W
!          XCI(I,J,K,4,4) = XWR(II,4,4) ! 16: N
!          XCI(I,J,K,5,1) = XWR(II,5,1) ! 17: T 
!          XCI(I,J,K,5,2) = XWR(II,5,2) ! 18: B
         XCI(I,J,K,5,3) = XWR(II,5,3) ! 19: P
         XCI(I,J,K,5,4) = XWR(II,5,4) ! 20: DUMMY
                  
         YCI(I,J,K,1,1) = YWR(II,1,1) ! 1: ne
         YCI(I,J,K,1,2) = YWR(II,1,2) ! 2: se
         YCI(I,J,K,1,3) = YWR(II,1,3) ! 3: sw
         YCI(I,J,K,1,4) = YWR(II,1,4) ! 4: nw
         YCI(I,J,K,2,1) = YWR(II,2,1) ! 5: te
         YCI(I,J,K,2,2) = YWR(II,2,2) ! 6: ts
         YCI(I,J,K,2,3) = YWR(II,2,3) ! 7: tw
         YCI(I,J,K,2,4) = YWR(II,2,4) ! 8: tn
         YCI(I,J,K,3,1) = YWR(II,3,1) ! 9: be
         YCI(I,J,K,3,2) = YWR(II,3,2) ! 10: bs
         YCI(I,J,K,3,3) = YWR(II,3,3) ! 11: bw
         YCI(I,J,K,3,4) = YWR(II,3,4) ! 12: bn
!          YCI(I,J,K,4,1) = YWR(II,4,1) ! 13: E
!          YCI(I,J,K,4,2) = YWR(II,4,2) ! 14: S
!          YCI(I,J,K,4,3) = YWR(II,4,3) ! 15: W
!          YCI(I,J,K,4,4) = YWR(II,4,4) ! 16: N
!          YCI(I,J,K,5,1) = YWR(II,5,1) ! 17: T 
!          YCI(I,J,K,5,2) = YWR(II,5,2) ! 18: B
         YCI(I,J,K,5,3) = YWR(II,5,3) ! 19: P
         YCI(I,J,K,5,4) = YWR(II,5,4) ! 20: DUMMY

         ZCI(I,J,K,1,1) = ZWR(II,1,1) ! 1: ne
         ZCI(I,J,K,1,2) = ZWR(II,1,2) ! 2: se
         ZCI(I,J,K,1,3) = ZWR(II,1,3) ! 3: sw
         ZCI(I,J,K,1,4) = ZWR(II,1,4) ! 4: nw
         ZCI(I,J,K,2,1) = ZWR(II,2,1) ! 5: te
         ZCI(I,J,K,2,2) = ZWR(II,2,2) ! 6: ts
         ZCI(I,J,K,2,3) = ZWR(II,2,3) ! 7: tw
         ZCI(I,J,K,2,4) = ZWR(II,2,4) ! 8: tn
         ZCI(I,J,K,3,1) = ZWR(II,3,1) ! 9: be
         ZCI(I,J,K,3,2) = ZWR(II,3,2) ! 10: bs
         ZCI(I,J,K,3,3) = ZWR(II,3,3) ! 11: bw
         ZCI(I,J,K,3,4) = ZWR(II,3,4) ! 12: bn
!          ZCI(I,J,K,4,1) = ZWR(II,4,1) ! 13: E
!          ZCI(I,J,K,4,2) = ZWR(II,4,2) ! 14: S
!          ZCI(I,J,K,4,3) = ZWR(II,4,3) ! 15: W
!          ZCI(I,J,K,4,4) = ZWR(II,4,4) ! 16: N
!          ZCI(I,J,K,5,1) = ZWR(II,5,1) ! 17: T 
!          ZCI(I,J,K,5,2) = ZWR(II,5,2) ! 18: B
         ZCI(I,J,K,5,3) = ZWR(II,5,3) ! 19: P
         ZCI(I,J,K,5,4) = ZWR(II,5,4) ! 20: DUMMY
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C       DIE KLEINEN KOORDINATEN, ALSO IN DER MITTE ZWISCHEN DEN VOLUMINA
         SMALLE(I,J,K,1) = XWR(II,4,1) ! 13: e
         SMALLE(I,J,K,2) = YWR(II,4,1) ! 13: e
         SMALLE(I,J,K,3) = ZWR(II,4,1) ! 13: e
         SMALLS(I,J,K,1) = XWR(II,4,2) ! 14: s
         SMALLS(I,J,K,2) = YWR(II,4,2) ! 14: s
         SMALLS(I,J,K,3) = ZWR(II,4,2) ! 14: s
         SMALLW(I,J,K,1) = XWR(II,4,3) ! 15: w
         SMALLW(I,J,K,2) = YWR(II,4,3) ! 15: w
         SMALLW(I,J,K,3) = ZWR(II,4,3) ! 15: w
         SMALLN(I,J,K,1) = XWR(II,4,4) ! 16: n
         SMALLN(I,J,K,2) = YWR(II,4,4) ! 16: n
         SMALLN(I,J,K,3) = ZWR(II,4,4) ! 16: n
         SMALLT(I,J,K,1) = XWR(II,5,1) ! 17: t
         SMALLT(I,J,K,2) = YWR(II,5,1) ! 17: t
         SMALLT(I,J,K,3) = ZWR(II,5,1) ! 17: t
         SMALLB(I,J,K,1) = XWR(II,5,2) ! 18: b
         SMALLB(I,J,K,2) = YWR(II,5,2) ! 18: b
         SMALLB(I,J,K,3) = ZWR(II,5,2) ! 18: b
C *********************************************************************
      IF(DBG_WR)THEN
      WRITE(97,*) I,J,K
      WRITE(97,100) 'tw: ',
     +XCI(I,J,K,2,3),YCI(I,J,K,2,3),ZCI(I,J,K,2,3)
      WRITE(97,100) 'ts: ',
     +XCI(I,J,K,2,2),YCI(I,J,K,2,2),ZCI(I,J,K,2,2)
      WRITE(97,100) 'te: ',
     +XCI(I,J,K,2,1),YCI(I,J,K,2,1),ZCI(I,J,K,2,1)
      WRITE(97,100) 'tn: ',
     +XCI(I,J,K,2,4),YCI(I,J,K,2,4),ZCI(I,J,K,2,4)
      
      WRITE(97,100) 'bw: ',
     +XCI(I,J,K,3,3),YCI(I,J,K,3,3),ZCI(I,J,K,3,3)
      WRITE(97,100) 'bs: ',
     +XCI(I,J,K,3,2),YCI(I,J,K,3,2),ZCI(I,J,K,3,2)
      WRITE(97,100) 'be: ',
     +XCI(I,J,K,3,1),YCI(I,J,K,3,1),ZCI(I,J,K,3,1)
      WRITE(97,100) 'bn: ',
     +XCI(I,J,K,3,4),YCI(I,J,K,3,4),ZCI(I,J,K,3,4)
     
      WRITE(97,100) 'sw: ',
     +XCI(I,J,K,1,3),YCI(I,J,K,1,3),ZCI(I,J,K,1,3)
      WRITE(97,100) 'se: ',
     +XCI(I,J,K,1,2),YCI(I,J,K,1,2),ZCI(I,J,K,1,2)
      WRITE(97,100) 'ne: ',
     +XCI(I,J,K,1,1),YCI(I,J,K,1,1),ZCI(I,J,K,1,1)
      WRITE(97,100) 'nw: ',
     +XCI(I,J,K,1,4),YCI(I,J,K,1,4),ZCI(I,J,K,1,4)

      WRITE(97,101) 'smalle: ',
     +SMALLE(I,J,K,1),SMALLE(I,J,K,2),SMALLE(I,J,K,3)
      WRITE(97,101) 'smalls: ',
     +SMALLS(I,J,K,1),SMALLS(I,J,K,2),SMALLS(I,J,K,3)
      WRITE(97,101) 'smallw: ',
     +SMALLW(I,J,K,1),SMALLW(I,J,K,2),SMALLW(I,J,K,3)
      WRITE(97,101) 'smalln: ',
     +SMALLN(I,J,K,1),SMALLN(I,J,K,2),SMALLN(I,J,K,3)
      WRITE(97,101) 'smallt: ',
     +SMALLT(I,J,K,1),SMALLT(I,J,K,2),SMALLT(I,J,K,3)
      WRITE(97,101) 'smallb: ',
     +SMALLB(I,J,K,1),SMALLB(I,J,K,2),SMALLB(I,J,K,3)

100   FORMAT(A4,1X,3(F10.2))
101   FORMAT(A8,1X,3(F10.2))
C *********************************************************************
      ENDIF

            ENDDO
         ENDDO
      ENDDO
      
      IF(II.NE.NE)THEN
      WRITE(*,*) II, NE, ' ERROR 20011'
      STOP
      ENDIF
      
C *********************************************************************
C WR: KORREKTUR, 05/01/22
C
C   ES WIRD DIE KOORDINATE DES MITTELPUNKTS DER BENACHTBARTEN ZELLE,
C   UND NICHT DIE KOORDINATE AUF DER GRENZFLAECHE ZWISCHEN DIESEN BEIDEN 
C   VOLUMINA BENOETIGT.
C
C WR: KORREKTUR, 06/02/11
C
C     ENTSPRECHEND PERIC, 1985 WERDEN NUN DIE RANDVOLUMINA AUF DIE 
C     KOORDINATE DES SEITENFLAECHENMITTELPUNKTES GELEGT;
C     ES HANDELT SICH ALSO UM NULL-VOLUMINA; 
C     DIE QUERABLEITUNGEN MUESSTEN (?) HIER GLEICH NULL SEIN!
C
      DO K = 1, K0
         DO J = 1, J0
            DO I = 1, I0
! 13: E
      IF(I.LT.I0)THEN
      XCI(I,J,K,4,1) =  CENTER(I+1,J,K,1)
      YCI(I,J,K,4,1) =  CENTER(I+1,J,K,2)
      ZCI(I,J,K,4,1) =  CENTER(I+1,J,K,3)
      ELSE
      XCI(I,J,K,4,1) =  SMALLE(I,J,K,1)
      YCI(I,J,K,4,1) =  SMALLE(I,J,K,2)
      ZCI(I,J,K,4,1) =  SMALLE(I,J,K,3)
      ENDIF
! 14: S         
      IF(J.GT.1)THEN
      XCI(I,J,K,4,2) =  CENTER(I,J-1,K,1)
      YCI(I,J,K,4,2) =  CENTER(I,J-1,K,2)
      ZCI(I,J,K,4,2) =  CENTER(I,J-1,K,3)
      ELSE
      XCI(I,J,K,4,2) =  SMALLS(I,J,K,1)
      YCI(I,J,K,4,2) =  SMALLS(I,J,K,2)
      ZCI(I,J,K,4,2) =  SMALLS(I,J,K,3)
      ENDIF
! 15: W
      IF(I.GT.1)THEN
      XCI(I,J,K,4,3) =  CENTER(I-1,J,K,1)
      YCI(I,J,K,4,3) =  CENTER(I-1,J,K,2)
      ZCI(I,J,K,4,3) =  CENTER(I-1,J,K,3)
      ELSE
      XCI(I,J,K,4,3) =  SMALLW(I,J,K,1)
      YCI(I,J,K,4,3) =  SMALLW(I,J,K,2)
      ZCI(I,J,K,4,3) =  SMALLW(I,J,K,3)
      ENDIF
! 16: N
      IF(J.LT.J0)THEN
      XCI(I,J,K,4,4) =  CENTER(I,J+1,K,1)
      YCI(I,J,K,4,4) =  CENTER(I,J+1,K,2)
      ZCI(I,J,K,4,4) =  CENTER(I,J+1,K,3)
      ELSE
      XCI(I,J,K,4,4) =  SMALLN(I,J,K,1)
      YCI(I,J,K,4,4) =  SMALLN(I,J,K,2)
      ZCI(I,J,K,4,4) =  SMALLN(I,J,K,3)
      ENDIF
! 17: T 
      IF(K.LT.K0)THEN
      XCI(I,J,K,5,1) =  CENTER(I,J,K+1,1)
      YCI(I,J,K,5,1) =  CENTER(I,J,K+1,2)
      ZCI(I,J,K,5,1) =  CENTER(I,J,K+1,3)
      ELSE
      XCI(I,J,K,5,1) =  SMALLT(I,J,K,1)
      YCI(I,J,K,5,1) =  SMALLT(I,J,K,2)
      ZCI(I,J,K,5,1) =  SMALLT(I,J,K,3)
      ENDIF
! 18: B
      IF(K.GT.1)THEN
      XCI(I,J,K,5,2) =  CENTER(I,J,K-1,1)
      YCI(I,J,K,5,2) =  CENTER(I,J,K-1,2)
      ZCI(I,J,K,5,2) =  CENTER(I,J,K-1,3)
      ELSE
      XCI(I,J,K,5,2) =  SMALLB(I,J,K,1)
      YCI(I,J,K,5,2) =  SMALLB(I,J,K,2)
      ZCI(I,J,K,5,2) =  SMALLB(I,J,K,3)
      ENDIF
! C *********************************************************************
             ENDDO
         ENDDO
      ENDDO
C **********************************************************************
C     GHOST-KNODES AT I = 0, I0+1, J = 0, J0+1, K = 0, K0+1
C           FOR PERIC, 1985 DIFFERENCING SCHEMES (SEE CDS3_*, CDS3)
C      
        DO K = 1,K0
         DO J = 1,J0
            DO I = 1,I0
               IF(I.EQ.1)THEN
C     WESTEN               
               IP2 = I-1
               JP2 = J
               KP2 = K
               CENTER(IP2,JP2,KP2,1) = SMALLW(I,J,K,1)
               CENTER(IP2,JP2,KP2,2) = SMALLW(I,J,K,2)
               CENTER(IP2,JP2,KP2,3) = SMALLW(I,J,K,3)
               ENDIF
C     SOUTH               
               IF(J.EQ.1)THEN
               CENTER(I,J-1,K,1) = SMALLS(I,J,K,1)
               CENTER(I,J-1,K,2) = SMALLS(I,J,K,2)
               CENTER(I,J-1,K,3) = SMALLS(I,J,K,3)               
               ENDIF
C     BOTTOM               
               IF(K.EQ.1)THEN
               CENTER(I,J,K-1,1) = SMALLB(I,J,K,1)
               CENTER(I,J,K-1,2) = SMALLB(I,J,K,2)
               CENTER(I,J,K-1,3) = SMALLB(I,J,K,3)               
               ENDIF
C     EAST               
               IF(I.EQ.I0)THEN
               CENTER(I+1,J,K,1) = SMALLE(I,J,K,1)
               CENTER(I+1,J,K,2) = SMALLE(I,J,K,2)
               CENTER(I+1,J,K,3) = SMALLE(I,J,K,3)
               ENDIF
C     NORTH
               IF(J.EQ.J0)THEN
               CENTER(I,J+1,K,1) = SMALLN(I,J,K,1)
               CENTER(I,J+1,K,2) = SMALLN(I,J,K,2)
               CENTER(I,J+1,K,3) = SMALLN(I,J,K,3)
               ENDIF
C     TOP
               IF(K.EQ.K0)THEN
               CENTER(I,J,K+1,1) = SMALLT(I,J,K,1)
               CENTER(I,J,K+1,2) = SMALLT(I,J,K,2)
               CENTER(I,J,K+1,3) = SMALLT(I,J,K,3)
               ENDIF
            ENDDO
         ENDDO
      ENDDO
C **********************************************************************      
                             
      ENDIF
      IF(DBG_WR)      CLOSE(97)
      RETURN
      END
