C
C  
C author Wolfram Ruehaak
C LGPL license
C Calculate the center of gravity of a tetrahedron
C Calculation is based on Bowyer & Woodmark, A programmer's geometry, 1983, p. 118 ff.
C 
C

      SUBROUTINE TETRACENTER(X,Y,Z,TC)

      IMPLICIT NONE

      DOUBLE PRECISION X(4), Y(4), Z(4)
      DOUBLE PRECISION TC(3)

      TC(1) = 0.25D0 * (X(1) + X(2) + X(3) + X(4))
      TC(2) = 0.25D0 * (Y(1) + Y(2) + Y(3) + Y(4))
      TC(3) = 0.25D0 * (Z(1) + Z(2) + Z(3) + Z(4))

      RETURN

      END

