C **********************************************************************
C     Wolfram Ruehaak, 04/07/27
C     05/01/22: Modified: New Index I0,J0,K0 instead of 
C                           (only one) Elementnumber
C **********************************************************************
C     BENOETIGT WERDEN:
C
C     X,Y,Z-Koordinate des Mittelpunkts des CV:
C     \-> XP,YP,ZP      --> MCENTER(NRELEMENTS,3);
C     dies ist der Massenschwerpunkt, ich brauche aber (wohl) den
C     Schnittpunkt der 
C
C     X,Y,Z-Koordinaten der Ecken des CV:
C     \-> X1,X2,X3,X4,X5,X6,X7,X8,
C         Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8,
C         Z1,Z2,Z3,Z4,Z5,Z6,Z7,Z8,
C
C     X,Y,Z-Koordinaten der Mittelpunkte der Kanten des CV
C           ne = 1, (1,1)
C           se = 2, (1,2)
C           sw = 3, (1,3)
C           nw = 4, (1,4)
C           te = 5, (2,1)
C           ts = 6, (2,2)
C           tw = 7, (2,3)
C           tn = 8, (2,4)
C           be = 9, (3,1)
C           bs = 10, (3,2)
C           bw = 11, (3,3)
C           bn = 12, (3,4)
C     Diese koennen berechnet werden indem die Koordinate (X,Y,Z) der 
C     Haelfte der euklidischen Distanz bestimmt wird.
C     Hierfuer noetig ist die SR --> CALCEM (CALCULATE EDGE MIDDLE)
C     mit X1,Y1,Z1,X2,Y2,Z2,
C
C     X,Y,Z-Koordinaten der Mittelpunkte der Seitenflaechen des CV:
C     (1) XE,YE,ZE, (2) XN,YN,ZN, (3) XT,YT,ZT
C     (4) XW,YW,ZW, (5) XS,YS,ZS, (6) XB,YB,ZB
C     Diese ergeben sich als Schnittpunkt der Verbindung der zwei Linien
C     die von den Mittelpunkten der Kanten der jeweiligen Seitenflaeche
C     starten.
C
C     Generell das Volumen des CV, die 6 Volumina der auf die 
C     Seitenflaechen verschobenen CV.
C     \-> VP, VE, VN, VT, VW, VS, VB      --> VP ist ja schon bekannt,
C           VE, ... koennen genauso mit CALCVOL2 berechnet werden!
C
C     Die DX(1 ... 3) also das Zellen Spacing in die drei curvilinearen 
C                       Koordinaten. 
C     --> dies ist die Euklidische Distanz zwischen den 
C                       6 Seitenmittelpunkten (s.o.) (?)
C
C **********************************************************************
      SUBROUTINE TRANSF3D()

      USE FELDER
      USE NO
      
      IMPLICIT NONE
      INCLUDE 'genrl.inc'
      INCLUDE 'transf3d.fi'
      include 'nogrid.fi'
      
      INTEGER II7,JJ7,KK7,I2,J2
      INTEGER I9,J9
      INTEGER SCR
      CHARACTER SIDE*6

C      BERECHNET WERDEN MUESSEN: XX0(5,4),YY0(5,4),ZZ0(5,4), DX(3)
      IF(LINFO.GE.2) WRITE(*,*) 'TF3D ', I0,J0,K0
C ---------------------------------------------------------------------
      IF(DBG_WR)THEN
      CLOSE(76)
      OPEN(76,FILE='transformation.out')
      ENDIF
      DO KK7 = 1, K0
      DO JJ7 = 1, J0
      DO II7 = 1, I0
      
      DO J = 1, 4
      DO I = 1, 5
      XX0(I,J) = XCI(II7,JJ7,KK7,I,J)
      YY0(I,J) = YCI(II7,JJ7,KK7,I,J)
      ZZ0(I,J) = ZCI(II7,JJ7,KK7,I,J)
      ENDDO
      ENDDO
C
C     PROVISIORISCH !?
C
      DX(1) = 1.D0
      DX(2) = 1.D0
      DX(3) = 1.D0

C **********************************************************************
      DO I = 1, 6 ! UEBER ALLE SEITEN DES CV: E,N,T,W,S,B

C     ZUERST  MUESSEN X,Y,Z also die lokalen Koordinaten der Knoten
C     berechnet werden, dann kann YPSILON aufgerufen werden:
     
      CALL YPSILON(I,XX0,YY0,ZZ0,DY)

      DO J2 = 1, 3
         DO I2 = 1, 3
            IF(DABS(DY(I2,J2)).LT.1.D-12)THEN
            DY(I2,J2) = 0.D0
            ENDIF
         ENDDO
      ENDDO  

C     Nun ist das DY berechnet worden.
C     Ausserdem muessen die transformierten DX(1 bis 3) bestimmt sein.
C     Jetzt kann BETA aufgerufen werden:     

      CALL BETASR(DX,DY,BETA,BS,B33)

C     DAS ERGEBNIS MUSS NUN ZUGESCHRIEBEN WERDEN:
C     BETA(I,J), BS(I,J) & B33(I,J)
C     Aus den BS muss das D(I,J) berechnet werden.
      
      CALL DORA(BS,D33)
      
      DC11(II7,JJ7,KK7,I) = D33(1,1)
      DC12(II7,JJ7,KK7,I) = D33(1,2)
      DC13(II7,JJ7,KK7,I) = D33(1,3)
      DC21(II7,JJ7,KK7,I) = D33(2,1)
      DC22(II7,JJ7,KK7,I) = D33(2,2)
      DC23(II7,JJ7,KK7,I) = D33(2,3)
      DC31(II7,JJ7,KK7,I) = D33(3,1)
      DC32(II7,JJ7,KK7,I) = D33(3,2)
      DC33(II7,JJ7,KK7,I) = D33(3,3)
      
      BS11(II7,JJ7,KK7,I) = BS(1,1)
      BS12(II7,JJ7,KK7,I) = BS(1,2)
      BS13(II7,JJ7,KK7,I) = BS(1,3)
      BS21(II7,JJ7,KK7,I) = BS(2,1)
      BS22(II7,JJ7,KK7,I) = BS(2,2)
      BS23(II7,JJ7,KK7,I) = BS(2,3)
      BS31(II7,JJ7,KK7,I) = BS(3,1)
      BS32(II7,JJ7,KK7,I) = BS(3,2)
      BS33(II7,JJ7,KK7,I) = BS(3,3)
      
      IF(I.EQ.1)THEN
      SIDE = 'East'
      ELSEIF(I.EQ.2)THEN
      SIDE = 'North'
      ELSEIF(I.EQ.3)THEN
      SIDE = 'Top'
      ELSEIF(I.EQ.4)THEN
      SIDE = 'West'
      ELSEIF(I.EQ.5)THEN
      SIDE = 'South'
      ELSEIF(I.EQ.6)THEN
      SIDE = 'Bottom'
      ENDIF
      
      IF(DBG_WR)THEN
      WRITE(76,'(A6)') SIDE
      WRITE(76,'(4(I5,1X))') II7,JJ7,KK7
      WRITE(76,'(A2)') 'DY'
      DO J9 = 1, 3
      WRITE(76,'(3(E15.5,1X))') (DY(I9,J9), I9 = 1, 3)
      ENDDO
      WRITE(76,'(A4)') 'beta'
      DO J9 = 1, 3
      WRITE(76,'(3(E15.5,1X))') (BETA(I9,J9), I9 = 1, 3)
      ENDDO
      WRITE(76,'(A1)') 'b'
      DO J9 = 1, 3
      WRITE(76,'(3(E15.5,1X))') (BS(I9,J9), I9 = 1, 3)
      ENDDO
      WRITE(76,'(A1)') 'B'
      DO J9 = 1, 3
      WRITE(76,'(3(E15.5,1X))') (B33(I9,J9), I9 = 1, 3)
      ENDDO
      WRITE(76,'(A1)') 'D'
      DO J9 = 1, 3
      WRITE(76,'(3(E15.5,1X))') (D33(I9,J9), I9 = 1, 3)
      ENDDO
      ENDIF
C *********************************************************************
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      
      IF(DBG_WR) CLOSE(76) 
            
      RETURN
      END

C **********************************************************************
C     GETS I, X, Y, Z, RETURNS DY
C     Jin, Gl. (3.17)
C **********************************************************************
      SUBROUTINE YPSILON(I,XX0,YY0,ZZ0,DY)
      
      IMPLICIT NONE
      INCLUDE 'transf3d.fi'
      INTEGER I,J

C      WRITE(*,*) 'STARTING YPSILON'

C   Numerierung der Knoten:
C   ne = 1, (1,1)
C   se = 2, (1,2)
C   sw = 3, (1,3)
C   nw = 4, (1,4)
C   te = 5, (2,1)
C   ts = 6, (2,2)
C   tw = 7, (2,3)
C   tn = 8, (2,4)
C   be = 9, (3,1)
C   bs = 10, (3,2)
C   bw = 11, (3,3)
C   bn = 12, (3,4)
C   E = 13, (4,1)
C   S = 14, (4,2
C   W = 15, (4,3)
C   N = 16, (4,4)
C   T = 17, (5,1)
C   B = 18, (5,2)
C   P = 19, (5,3)
      IF(I.EQ.1)THEN
C   Osten:
      DY(1,1)= XX0(4,1)-XX0(5,3) ! E - P
      DY(1,2)= XX0(1,1)-XX0(1,2) ! ne - se
      DY(1,3)= XX0(2,1)-XX0(3,1) ! te - be
      DY(2,1)= YY0(4,1)-YY0(5,3) ! E - P
      DY(2,2)= YY0(1,1)-YY0(1,2) ! ne -se
      DY(2,3)= YY0(2,1)-YY0(3,1) ! te - be
      DY(3,1)= ZZ0(4,1)-ZZ0(5,3) ! E - P
      DY(3,2)= ZZ0(1,1)-ZZ0(1,2) ! ne - se
      DY(3,3)= ZZ0(2,1)-ZZ0(3,1) ! te - be      
      ELSEIF(I.EQ.2)THEN
C   Norden:
      DY(1,1)= XX0(1,1)-XX0(1,4) ! ne - nw
      DY(1,2)= XX0(4,4)-XX0(5,3) ! N - P
      DY(1,3)= XX0(2,4)-XX0(3,4) ! tn - bn
      DY(2,1)= YY0(1,1)-YY0(1,4) !
      DY(2,2)= YY0(4,4)-YY0(5,3) ! 
      DY(2,3)= YY0(2,4)-YY0(3,4) !  
      DY(3,1)= ZZ0(1,1)-ZZ0(1,4) !   
      DY(3,2)= ZZ0(4,4)-ZZ0(5,3) ! 
      DY(3,3)= ZZ0(2,4)-ZZ0(3,4) !  
      ELSEIF(I.EQ.3)THEN      
C   Top :
      DY(1,1)= XX0(2,1)-XX0(2,3) ! te - tw
      DY(1,2)= XX0(2,4)-XX0(2,2) ! tn - ts
      DY(1,3)= XX0(5,1)-XX0(5,3) ! T - P
      DY(2,1)= YY0(2,1)-YY0(2,3) !
      DY(2,2)= YY0(2,4)-YY0(2,2) !
      DY(2,3)= YY0(5,1)-YY0(5,3) !
      DY(3,1)= ZZ0(2,1)-ZZ0(2,3) !
      DY(3,2)= ZZ0(2,4)-ZZ0(2,2) !
      DY(3,3)= ZZ0(5,1)-ZZ0(5,3) !
      ELSEIF(I.EQ.4)THEN
C   Westen:
      DY(1,1)= XX0(5,3)-XX0(4,3) ! W - P
      DY(1,2)= XX0(1,4)-XX0(1,3) ! nw - sw
      DY(1,3)= XX0(2,3)-XX0(3,3) ! tw - bw
      DY(2,1)= YY0(5,3)-YY0(4,3) !
      DY(2,2)= YY0(1,4)-YY0(1,3) !
      DY(2,3)= YY0(2,3)-YY0(3,3) !
      DY(3,1)= ZZ0(5,3)-ZZ0(4,3) !
      DY(3,2)= ZZ0(1,4)-ZZ0(1,3) !
      DY(3,3)= ZZ0(2,3)-ZZ0(3,3) !
      ELSEIF(I.EQ.5)THEN
C   Sueden:
      DY(1,1)= XX0(1,2)-XX0(1,3) ! se - sw
      DY(1,2)= XX0(5,3)-XX0(4,2) ! P - S
      DY(1,3)= XX0(2,2)-XX0(3,2) ! ts - bs
      DY(2,1)= YY0(1,2)-YY0(1,3) !
      DY(2,2)= YY0(5,3)-YY0(4,2) !
      DY(2,3)= YY0(2,2)-YY0(3,2) !
      DY(3,1)= ZZ0(1,2)-ZZ0(1,3) !
      DY(3,2)= ZZ0(5,3)-ZZ0(4,2) !
      DY(3,3)= ZZ0(2,2)-ZZ0(3,2) !
      ELSEIF(I.EQ.6)THEN
C   Buttom:
      DY(1,1)= XX0(3,1)-XX0(3,3) ! be - bw
      DY(1,2)= XX0(3,4)-XX0(3,2) ! bn - bs
      DY(1,3)= XX0(5,3)-XX0(5,2) ! P - B
      DY(2,1)= YY0(3,1)-YY0(3,3) !
      DY(2,2)= YY0(3,4)-YY0(3,2) !
      DY(2,3)= YY0(5,3)-YY0(5,2) !
      DY(3,1)= ZZ0(3,1)-ZZ0(3,3) !
      DY(3,2)= ZZ0(3,4)-ZZ0(3,2) !
      DY(3,3)= ZZ0(5,3)-ZZ0(5,2) !
      ENDIF
      
      RETURN
      END
C **********************************************************************
C
C SR BETA WIRD FUER JEDE SEITENFLAECHE DES CV (E,N,W,S,T,B)
C SEPERAT AUFGERUFEN, DAHER ENTFAELLT HIER DER DRITTE INIDIZE.
C
C **********************************************************************
C
C     GETS: DX(I) & DY(I,J), RETURNS: BETA(I,J), BS(I,J) & B33(I,J)
C
      SUBROUTINE BETASR(DX,DY,BETA,BS,B33)
      
      IMPLICIT NONE

      INCLUDE 'transf3d.fi'

C      WRITE(*,*) 'STARTING BETASR'
C    
C     DX1, DX2, DX3 repraesentieren die Maschenweiten jeweils in den 
C     Koordinatenrichtungen X1, X2 und X3. DYIJM sind Inkremente fuer 
C     die Oberflaeche M: Inkremente in kartesischen Koordinaten YI 
C     (Y1 = X-Richtung, Y2 = Y-Richtung,  Y3 = Z-Richtung)
C     entlang beliebiger Koordinaten XJ. Dabei sind die kartesischen 
C     Koordinaatenwerte von Knoten die einzigen bentigten geometrischen
C     Informationen.
C     Jede Masche ist von den die Eckknoten verbindenden geraden Linien
C     gebildet. Es ergeben sich DYIJM.
C
C     BS ist klein B (also b)
C      
C     Anscheinend muss DY fuer auch BS (und die anderen Variablen)
C     fuer jede Seitenflaeche berechnet werden, so dass dann die 
C     jeweiligen (s.o.) DY genommen werden muessen ???
C
C     Dies sollte in zwei getrennte Subroutinen verlagert werden, damit
C     es eine mit reinen 2D-Element (s.u.) gibt.
C
C     Jin, Gl. (3.16)
C
      BS(1,1) = (DY(2,2)*DY(3,3)-DY(2,3)*DY(3,2))
      BS(2,1) = (DY(1,3)*DY(3,2)-DY(1,2)*DY(3,3))
      BS(3,1) = (DY(1,2)*DY(2,3)-DY(1,3)*DY(2,2))
      BS(1,2) = (DY(2,3)*DY(3,1)-DY(2,1)*DY(3,3))
      BS(2,2) = (DY(1,1)*DY(3,3)-DY(1,3)*DY(3,1))
      BS(3,2) = (DY(1,3)*DY(2,1)-DY(1,1)*DY(2,3))
      BS(1,3) = (DY(2,1)*DY(3,2)-DY(2,2)*DY(3,1))
      BS(2,3) = (DY(1,2)*DY(3,1)-DY(1,1)*DY(3,2))
      BS(3,3) = (DY(1,1)*DY(2,2)-DY(1,2)*DY(2,1))
            
      BETA(1,1) = 1.D0/(DX(2)*DX(3))*BS(1,1)
      BETA(2,1) = 1.D0/(DX(2)*DX(3))*BS(2,1)
      BETA(3,1) = 1.D0/(DX(2)*DX(3))*BS(3,1)
      BETA(1,2) = 1.D0/(DX(1)*DX(3))*BS(1,2)
      BETA(2,2) = 1.D0/(DX(1)*DX(3))*BS(2,2)
      BETA(3,2) = 1.D0/(DX(1)*DX(3))*BS(3,2)
      BETA(1,3) = 1.D0/(DX(1)*DX(2))*BS(1,3)
      BETA(2,3) = 1.D0/(DX(1)*DX(2))*BS(2,3)
      BETA(3,3) = 1.D0/(DX(1)*DX(2))*BS(3,3)      
C      
C      Jin, Gl. (3.12)
C
      B33(1,1) = 
     & BETA(1,1)*BETA(1,1)+BETA(2,1)*BETA(2,1)+BETA(3,1)*BETA(3,1)
      B33(1,2) = 
     & BETA(1,2)*BETA(1,1)+BETA(2,2)*BETA(2,1)+BETA(3,2)*BETA(3,1)
      B33(1,3) = 
     & BETA(1,3)*BETA(1,1)+BETA(2,3)*BETA(2,1)+BETA(3,3)*BETA(3,1)
      
      B33(2,1) = B33(1,2)
      B33(2,2) = 
     & BETA(1,2)*BETA(1,2)+BETA(2,2)*BETA(2,2)+BETA(3,2)*BETA(3,2)
      B33(2,3) = 
     & BETA(1,3)*BETA(1,2)+BETA(2,3)*BETA(2,2)+BETA(3,3)*BETA(3,2)

      B33(3,1) = B33(1,3)
      B33(3,2) = B33(2,3)
      B33(3,3) = 
     & BETA(1,3)*BETA(1,3)+BETA(2,3)*BETA(2,3)+BETA(3,3)*BETA(3,3)

      RETURN
      END

C **********************************************************************
C      Jin, Gl. 3.30
C   WICHTIG: DIE BS ENTSPRECHEN DEN KLEIN B AUS GL. 3.16!!!
C   DIE VARIABLE B IST FUER WAS ANDERES.
C **********************************************************************
      SUBROUTINE DORA(BS,D33)
             
      IMPLICIT NONE
      INCLUDE 'transf3d.fi'

C      WRITE(*,*) 'STARTING DORA'

      D33(1,1) = BS(1,1)*BS(1,1)+BS(2,1)*BS(2,1)+BS(3,1)*BS(3,1)
      D33(1,2) = BS(1,2)*BS(1,1)+BS(2,2)*BS(2,1)+BS(3,2)*BS(3,1)
      D33(1,3) = BS(1,3)*BS(1,1)+BS(2,3)*BS(2,1)+BS(3,3)*BS(3,1)
      D33(2,1) = D33(1,2)
      D33(2,2) = BS(1,2)*BS(1,2)+BS(2,2)*BS(2,2)+BS(3,2)*BS(3,2)
      D33(2,3) = BS(1,3)*BS(1,2)+BS(2,3)*BS(2,2)+BS(3,3)*BS(3,2)
      D33(3,1) = D33(1,3)
      D33(3,2) = D33(2,3)
      D33(3,3) = BS(1,3)*BS(1,3)+BS(2,3)*BS(2,3)+BS(3,3)*BS(3,3)
      
      RETURN
      END
