      
      
      DOUBLE PRECISION FUNCTION VOLTH(A,B,C,D)
C WR      IMPLICIT LOGICAL (A-Z)
      
      IMPLICIT NONE
      
      DOUBLE PRECISION A(3),B(3),C(3),D(3)
C
C     Written and copyright by:
C        Barry Joe, Dept. of Computing Science, Univ. of Alberta
C        Edmonton, Alberta, Canada  T6G 2H1
C        Phone: (403) 492-5757      Email: barry@cs.ualberta.ca
C
C     Purpose: Compute 6 times volume of tetrahedron.
C
C     Input parameters:
C        A(1:3),B(1:3),C(1:3),D(1:3) - 4 vertices of tetrahedron
C
C     Returned function value:
C        VOLTH - 6 * volume of tetrahedron
C
      INTEGER I
      DOUBLE PRECISION U(3),V(3),W(3)
C
      DO 10 I = 1,3
	 U(I) = B(I) - A(I)
	 V(I) = C(I) - A(I)
	 W(I) = D(I) - A(I)
   10 CONTINUE
      VOLTH = ABS( U(1)*(V(2)*W(3) - V(3)*W(2)) + U(2)*(V(3)*W(1) -
     $   V(1)*W(3)) + U(3)*(V(1)*W(2) - V(2)*W(1)) )

      RETURN
      END


