C************************************************************************
C     CALCULATE HEAT-TRANSPORT CROSS-DERIVATIVES 
C     FOR SEMI-IMLICITE SOLUTION
C************************************************************************      
      SUBROUTINE HTCD()

      USE FELDER
      USE NO
      IMPLICIT NONE
      
      include 'genrl.inc'
      include 'genrlc.inc'
      include 'temp.inc'
      include 'notcoef.fi'
      include 'nogrid.fi'
      
      DOUBLE PRECISION CALCVA
      
      
      

      IF(LINFO.GE.2) WRITE(*,*)'HTCD working'
            
C **********************************************************************
      CALL BORDERPHI()
      CALL CDS3_T()
C **********************************************************************

      CALL INVAL (WR_L,0.D0)
      CALL INVAL (WR_P,0.D0)
      CALL INVAL (WR_Q,0.D0)
      CALL INVAL (WR_R,0.D0)
      CALL INVAL (WR_S,0.D0)
      CALL INVAL (WR_U,0.D0)
      CALL INVAL (WR_V,0.D0)

      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
      IF(I.LT.I0)THEN
      dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   CENTER(I+1,J,K,1),CENTER(I+1,J,K,2),CENTER(I+1,J,K,3))
      dxx2 = CALCED(
     +   SMALLE(I,J,K,1),SMALLE(I,J,K,2),SMALLE(I,J,K,3),
     +   SMALLW(I,J,K,1),SMALLW(I,J,K,2),SMALLW(I,J,K,3))
      dxx3 = CALCED(
     +   SMALLE(I+1,J,K,1),SMALLE(I+1,J,K,2),SMALLE(I+1,J,K,3),
     +   SMALLW(I+1,J,K,1),SMALLW(I+1,J,K,2),SMALLW(I+1,J,K,3))
      aa1 = WLX(I,J,K)
      aa2 = WLX(I+1,J,K)
      FACA_e = CALCFA(aa1,aa2,dxx1,dxx2,dxx3)
      ELSE
      FACA_e = WLX(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(I.GT.1)THEN
      dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   CENTER(I-1,J,K,1),CENTER(I-1,J,K,2),CENTER(I-1,J,K,3))
      dxx2 = CALCED(
     +   SMALLE(I,J,K,1),SMALLE(I,J,K,2),SMALLE(I,J,K,3),
     +   SMALLW(I,J,K,1),SMALLW(I,J,K,2),SMALLW(I,J,K,3))
      dxx3 = CALCED(
     +   SMALLE(I-1,J,K,1),SMALLE(I-1,J,K,2),SMALLE(I-1,J,K,3),
     +   SMALLW(I-1,J,K,1),SMALLW(I-1,J,K,2),SMALLW(I-1,J,K,3))
      aa1 = WLX(I,J,K)
      aa2 = WLX(I-1,J,K)
      FACA_w = CALCFA(aa1,aa2,dxx1,dxx2,dxx3)
      ELSE
      FACA_w = WLX(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(J.LT.J0)THEN
      dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   CENTER(I,J+1,K,1),CENTER(I,J+1,K,2),CENTER(I,J+1,K,3))
      dxx2 = CALCED(
     +   SMALLN(I,J,K,1),SMALLN(I,J,K,2),SMALLN(I,J,K,3),
     +   SMALLS(I,J,K,1),SMALLS(I,J,K,2),SMALLS(I,J,K,3))
      dxx3 = CALCED(
     +   SMALLN(I,J+1,K,1),SMALLN(I,J+1,K,2),SMALLN(I,J+1,K,3),
     +   SMALLS(I,J+1,K,1),SMALLS(I,J+1,K,2),SMALLS(I,J+1,K,3))
      aa1 = WLY(I,J,K)
      aa2 = WLY(I,J+1,K)
      FACA_n = CALCFA(aa1,aa2,dxx1,dxx2,dxx3)
      ELSE
      FACA_n = WLY(I,J,K) ! /RHOCG(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(J.GT.1)THEN
      dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   CENTER(I,J-1,K,1),CENTER(I,J-1,K,2),CENTER(I,J-1,K,3))
      dxx2 = CALCED(
     +   SMALLN(I,J,K,1),SMALLN(I,J,K,2),SMALLN(I,J,K,3),
     +   SMALLS(I,J,K,1),SMALLS(I,J,K,2),SMALLS(I,J,K,3))
      dxx3 = CALCED(
     +   SMALLN(I,J-1,K,1),SMALLN(I,J-1,K,2),SMALLN(I,J-1,K,3),
     +   SMALLS(I,J-1,K,1),SMALLS(I,J-1,K,2),SMALLS(I,J-1,K,3))
      aa1 = WLY(I,J,K)
      aa2 = WLY(I,J-1,K)
      FACA_s = CALCFA(aa1,aa2,dxx1,dxx2,dxx3)
      ELSE
      FACA_s = WLY(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(K.LT.K0)THEN
      dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   CENTER(I,J,K+1,1),CENTER(I,J,K+1,2),CENTER(I,J,K+1,3))
      dxx2 = CALCED(
     +   SMALLT(I,J,K,1),SMALLT(I,J,K,2),SMALLT(I,J,K,3),
     +   SMALLB(I,J,K,1),SMALLB(I,J,K,2),SMALLB(I,J,K,3))
      dxx3 = CALCED(
     +   SMALLT(I,J,K+1,1),SMALLT(I,J,K+1,2),SMALLT(I,J,K+1,3),
     +   SMALLB(I,J,K+1,1),SMALLB(I,J,K+1,2),SMALLB(I,J,K+1,3))
      aa1 = WLZ(I,J,K)
      aa2 = WLZ(I,J,K+1)
      FACA_t = CALCFA(aa1,aa2,dxx1,dxx2,dxx3)
      ELSE
      FACA_t = WLZ(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(K.GT.1)THEN
      dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   CENTER(I,J,K-1,1),CENTER(I,J,K-1,2),CENTER(I,J,K-1,3))
      dxx2 = CALCED(
     +   SMALLT(I,J,K,1),SMALLT(I,J,K,2),SMALLT(I,J,K,3),
     +   SMALLB(I,J,K,1),SMALLB(I,J,K,2),SMALLB(I,J,K,3))
      dxx3 = CALCED(
     +   SMALLT(I,J,K-1,1),SMALLT(I,J,K-1,2),SMALLT(I,J,K-1,3),
     +   SMALLB(I,J,K-1,1),SMALLB(I,J,K-1,2),SMALLB(I,J,K-1,3))
      aa1 = WLZ(I,J,K)
      aa2 = WLZ(I,J,K-1)
      FACA_b = CALCFA(aa1,aa2,dxx1,dxx2,dxx3)
      ELSE
      FACA_b = WLZ(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
      phi_e = FACA_e/VE(I,J,K)
      phi_w = FACA_w/VW(I,J,K)
      phi_n = FACA_n/VN(I,J,K)
      phi_s = FACA_s/VS(I,J,K)
      phi_t = FACA_t/VT(I,J,K)
      phi_b = FACA_b/VB(I,J,K)      

! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     EAST-FACE ne-se
001   T_nese=(TEMP_n(I,J,K)  -TEMP_s(I,J,K))  *(1.D0-FE_CDS(I,J,K,1))+
     &       (TEMP_n(I+1,J,K)-TEMP_s(I+1,J,K))*      FE_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     EAST-FACE te-be
002   T_tebe=(TEMP_t(I,J,K)  -TEMP_b(I,J,K))  *(1.D0-FE_CDS(I,J,K,1))+
     &       (TEMP_t(I+1,J,K)-TEMP_b(I+1,J,K))*      FE_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     WEST-FACE nw-sw
003   T_nwsw=(TEMP_n(I,J,K)  -TEMP_s(I,J,K))  *(1.D0-FW_CDS(I,J,K,1))+
     &       (TEMP_n(I-1,J,K)-TEMP_s(I-1,J,K))*      FW_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     WEST-FACE tw-bw
004   T_twbw=(TEMP_t(I,J,K)  -TEMP_b(I,J,K))  *(1.D0-FW_CDS(I,J,K,1))+
     &       (TEMP_t(I-1,J,K)-TEMP_b(I-1,J,K))*      FW_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     NORTH-FACE ne-nw
005   T_nenw=(TEMP_e(I,J,K)  -TEMP_w(I,J,K))  *(1.D0-FN_CDS(I,J,K,1))+
     &       (TEMP_e(I,J+1,K)-TEMP_w(I,J+1,K))*      FN_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     NORTH-FACE tn-bn
006   T_tnbn=(TEMP_t(I,J,K)  -TEMP_b(I,J,K))  *(1.D0-FN_CDS(I,J,K,1))+
     &       (TEMP_t(I,J+1,K)-TEMP_b(I,J+1,K))*      FN_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     SOUTH-FACE se-sw
007   T_sesw=(TEMP_e(I,J,K)  -TEMP_w(I,J,K))  *(1.D0-FS_CDS(I,J,K,1))+
     &       (TEMP_e(I,J-1,K)-TEMP_w(I,J-1,K))*      FS_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     SOUTH-FACE ts-bs
008   T_tsbs=(TEMP_t(I,J,K)  -TEMP_b(I,J,K))  *(1.D0-FS_CDS(I,J,K,1))+
     &       (TEMP_t(I,J-1,K)-TEMP_b(I,J-1,K))*      FS_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     TOP-FACE tn-ts
009   T_tnts=(TEMP_n(I,J,K)  -TEMP_s(I,J,K))  *(1.D0-FT_CDS(I,J,K,1))+
     &       (TEMP_n(I,J,K+1)-TEMP_s(I,J,K+1))*      FT_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     TOP-FACE te-tw
010   T_tetw=(TEMP_e(I,J,K)  -TEMP_w(I,J,K))  *(1.D0-FT_CDS(I,J,K,1))+
     &       (TEMP_e(I,J,K+1)-TEMP_w(I,J,K+1))*      FT_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     BASE-FACE bn-bs
011   T_bnbs=(TEMP_n(I,J,K)  -TEMP_s(I,J,K))  *(1.D0-FB_CDS(I,J,K,1))+
     &       (TEMP_n(I,J,K-1)-TEMP_s(I,J,K-1))*      FB_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     BASE-FACE be-bw
012   T_bebw=(TEMP_e(I,J,K)  -TEMP_w(I,J,K))  *(1.D0-FB_CDS(I,J,K,1))+
     &       (TEMP_e(I,J,K-1)-TEMP_w(I,J,K-1))*      FB_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
      DT1 = DC12(I,J,K,1)*T_nese+DC13(I,J,K,1)*T_tebe   ! E
      DT2 = DC12(I,J,K,4)*T_nwsw+DC13(I,J,K,4)*T_twbw   ! W
      DT3 = DC21(I,J,K,2)*T_nenw+DC23(I,J,K,2)*T_tnbn   ! N
      DT4 = DC21(I,J,K,5)*T_sesw+DC23(I,J,K,5)*T_tsbs   ! S
      DT5 = DC32(I,J,K,3)*T_tnts+DC31(I,J,K,3)*T_tetw   ! T
      DT6 = DC32(I,J,K,6)*T_bnbs+DC31(I,J,K,6)*T_bebw   ! B            
C ---------------------------------------------------------------------
      WR_V(I,J,K) = phi_b  * DT6
C ---------------------------------------------------------------------
      WR_S(I,J,K) = phi_s  * DT4
C ---------------------------------------------------------------------
      WR_Q(I,J,K) = phi_w  * DT2
C ---------------------------------------------------------------------
      WR_P(I,J,K) = phi_e  * DT1
C ---------------------------------------------------------------------
      WR_R(I,J,K) = phi_n  * DT3
C ---------------------------------------------------------------------
      WR_U(I,J,K) = phi_t  * DT5
C ---------------------------------------------------------------------
      IF(I.EQ.1)THEN
      WR_Q(I,J,K) = 0.D0
      ENDIF
      IF(J.EQ.1)THEN
      WR_S(I,J,K) = 0.D0
      ENDIF
      IF(K.EQ.1)THEN
      WR_V(I,J,K) = 0.D0
      ENDIF
      IF(I.EQ.I0)THEN
      WR_P(I,J,K) = 0.D0
      ENDIF
      IF(J.EQ.J0)THEN
      WR_R(I,J,K) = 0.D0
      ENDIF
      IF(K.EQ.K0)THEN
      WR_U(I,J,K) = 0.D0      
      ENDIF      

            ENDDO
         ENDDO
      ENDDO


      RETURN
      END
