      MODULE NO
! BEGIN WR
      DOUBLE PRECISION VERYSMALL,EXSMALL
      PARAMETER(VERYSMALL=1.0D-12,EXSMALL=1.0D-32)
      DOUBLE PRECISION ATMO
      DOUBLE PRECISION MDEPTH
      DOUBLE PRECISION UGRAV(3)
      DOUBLE PRECISION REFLVL
      INTEGER GRIDFILE
! UPWINDING      
      LOGICAL           UDS
!       PARAMETER(        UDS = .TRUE.)
! NO FLOW IN Y-DIRECTION - SEMI 2D-CASE      
      INTEGER           TEST2D      
!       PARAMETER(        TEST2D = .TRUE.)
! TIME WEIGHTING OF THE VELOCITY + SMOOTHING IN CASE OF VIOLATION OF STABILTY CRITERIA      
      LOGICAL           VELTWT
!       PARAMETER(        VELTWT = .TRUE.)
! NO DENSITY EFFECTS - ESPECIALLY FOR DOMENICO & PALCIAUSKAS VERIFICATION
      LOGICAL           DPVERIF
!      PARAMETER(        DPVERIF = .FALSE.)
! USE POLYNOMAL DENSITY-TEMPERATURE RELATIONSHIP
      LOGICAL           BPOLYRHO
!       PARAMETER(        BPOLYRHO = .TRUE.)
! USE STATIC VISCOSITY (EVERYWHERE) AT REFERENCE TEMPERATURE
      LOGICAL           BSTVISC
!       PARAMETER(        BSTVISC = .TRUE.)

! SCALE (REDUCE) VELOCITY BY THIS VALUE - GIVES *WRONG* RESULTS!!!
      DOUBLE PRECISION VELSCL
! SET VELOCITY AT THE OUTER BOUNDARY EQUAL ZERO (IF EQ.1.)
      INTEGER VBZERO
! 070517: new approach for semi-implicte solution
      INTEGER SEMISTAT
      
      LOGICAL LAVISH      
      PARAMETER(LAVISH = .TRUE.)

C ---------------------------------------------------------------------
C     WR STUFF FOR THE NON-ORTHOGONAL GRID
C
C   I,J,K-Indizierte Variablen fuer das Non-Orthogonale (NO) Gitter
C
C Darcy-Geschwindigkeiten
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VX_E(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VX_W(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VY_N(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VY_S(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VZ_T(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VZ_B(:,:,:)

      DOUBLE PRECISION , SAVE , ALLOCATABLE :: XXI(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: YYI(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: ZZI(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: XXI8(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: YYI8(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: ZZI8(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: MATXYZ(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: MAT8XYZ(:,:,:)      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: CENTER(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DEPTH(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: HEIGHT(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: CV(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC11(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC12(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC13(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC21(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC22(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC23(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC31(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC32(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DC33(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS11(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS12(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS13(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS21(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS22(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS23(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS31(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS32(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: BS33(:,:,:,:)      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: XCI(:,:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: YCI(:,:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: ZCI(:,:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VP(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VE(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VS(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VW(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VN(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VT(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: VB(:,:,:)
C WR SOLVER STUFF      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_P(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_Q(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_R(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_S(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_U(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_V(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: WR_L(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: RHOCG(:,:,:)
      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: SMALLE(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: SMALLW(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: SMALLN(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: SMALLS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: SMALLT(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: SMALLB(:,:,:,:)
      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: E_INTSC(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: W_INTSC(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: N_INTSC(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: S_INTSC(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: T_INTSC(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: B_INTSC(:,:,:,:)      
      
      INTEGER , SAVE , ALLOCATABLE :: BNR(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: XXVTC(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: YYVTC(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: ZZVTC(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TTVTC(:,:,:)
      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: MATVTC(:,:,:)
            
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: HEAD(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: RHOF0(:,:,:)
C ---------------------------------------------------------------------
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FP_CDS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FB_CDS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FW_CDS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FS_CDS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FE_CDS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FT_CDS(:,:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: FN_CDS(:,:,:,:)
      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TEMP_n(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TEMP_s(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TEMP_e(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TEMP_w(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TEMP_t(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: TEMP_b(:,:,:)

      DOUBLE PRECISION , SAVE , ALLOCATABLE :: P_n(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: P_s(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: P_e(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: P_w(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: P_t(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: P_b(:,:,:)

      DOUBLE PRECISION , SAVE , ALLOCATABLE :: D_n(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: D_s(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: D_e(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: D_w(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: D_t(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: D_b(:,:,:)
            
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: drho_old(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: DVISC_old(:,:,:)

      DOUBLE PRECISION , SAVE , ALLOCATABLE :: COURTX(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: COURTY(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: COURTZ(:,:,:)
      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: PECLTX(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: PECLTY(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: PECLTZ(:,:,:)


      DOUBLE PRECISION , SAVE , ALLOCATABLE :: AREA_E(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: AREA_W(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: AREA_S(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: AREA_N(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: AREA_T(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: AREA_B(:,:,:)

      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVE(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVW(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVN(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVS(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVB(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVT(:,:,:)
      
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVE2(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVW2(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVN2(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVS2(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVB2(:,:,:)
      DOUBLE PRECISION , SAVE , ALLOCATABLE :: GRAVT2(:,:,:)
      
! END WR      
      END MODULE NO
