C     Last change:  WR   22 Jul 2007   16:00
C     Last change:  WR   15 Jul 2006   15:00
C     Last change:  WR   15 Jun 2006   15:00
C     Last change:  WR   19 Feb 2006   15:00
C     Last change:  WR   15 Nov 2005   19:00
C     Last change:  WR   21 Feb 2004   16:28 
C     Last change:  WR   20 Jun 2004   20:17
C************************************************************************
C* SNO-SUBROUTINE NOFCOEF                                               *
C************************************************************************
C* C.Clauser 1994, W.Ruehaak 2004,2005,2006,2007                        *
C************************************************************************      
      SUBROUTINE NOFCOEF()

      USE FELDER
      USE NO

      IMPLICIT NONE

      include 'genrl.inc'
      include 'genrlc.inc'
      include 'flow.inc'
      include 'nofcoef.fi'
      include 'nogrid.fi'
      
      INTEGER           IS1,JS1,KS1,IS2,JS2,KS2,IP2,JP2,KP2
      
      INTEGER           MTPI,MTPJ,MTPK,IWRSCR
      
      DOUBLE PRECISION  ED1,ED2
      DOUBLE PRECISION  ALFA,ALFM,ALFP,HILF,PORO,QM,QP,
     +                  RCM,RCM2,RCP,RCP2,
     +                  RCSUMM,RCSUMP,RM,TSUM,U,VABS,VSUM,
     +                  XLAMM,XLAMP,XLSUMM,XLSUMP,V,
     +                  porf,pori
      DOUBLE PRECISION  rho_e,rho_w,rho_n,rho_s,rho_t,rho_b
      DOUBLE PRECISION  beta_e,beta_w,beta_n,beta_s,beta_t,beta_b
      DOUBLE PRECISION  rho0e,rho0w,rho0n,rho0s,rho0t,rho0b
caw mpot=0, means 7-point star
      integer           mpot, pot
      common /pot/      mpot, pot
      DOUBLE PRECISION  DRATIO,MEANCD,MEANND,MINDR,MAXDR
      DOUBLE PRECISION  SRCE,SRCE2,SRCE3
      DOUBLE PRECISION  NOBUOY,HMHYCON
      DOUBLE PRECISION  PSI_T,PSI_B,PSI_E,PSI_W,PSI_N,PSI_S
      
      DOUBLE PRECISION  D_nese,D_tebe,D_nwsw,D_twbw,D_nenw,D_tnbn,
     +                  D_sesw,D_tsbs,D_tnts,D_tetw,D_bnbs,D_bebw,
     +                  DD1,DD2,DD3,DD4,DD5,DD6
      
      MINDR = +1.D64
      MAXDR = -1.D64

      IF(LINFO.GE.2) WRITE(*,*)'NOFCOEF working'

C **********************************************************************
      CALL BORDERPHI()
      CALL CDS3_P()
      CALL CDS3_D()
C **********************************************************************

      IF(STAT.EQ.'STAT')THEN
      WRITE(*,*) 
     +'ERROR STEADY STATE CALCULATION 
     +IS NOT POSSIBLE WITH THIS VERSION!'
!       STOP
      ENDIF
      
      WRITE(*,'(7(A6))') 'BCs: ',
     + TOPF,BASEF,SEITEF(1),SEITEF(2),SEITEF(3),SEITEF(4)

      IF(DBG_WR)THEN
      CLOSE(93)
      OPEN(93,FILE='diff-fcoef.out')
      ENDIF
      
C
C - - BERECHNEN DER 7 LINKSSEITIGEN SIP-KOEFFIZIENTEN  - - - - - - - - -
C
C WR  INITIALIZE THE 7 SIP-COEFFICIENTS WITH ZERO
      CALL INVAL (A,0.D0)
      CALL INVAL (B,0.D0)
      CALL INVAL (C,0.D0)
      CALL INVAL (D,0.D0)
      CALL INVAL (E,0.D0)
      CALL INVAL (F,0.D0)
      CALL INVAL (G,0.D0)
      CALL INVAL (W,0.D0)
C ---------------------------------------------------------------------      
      CALL INVAL (WR_L,0.D0)
      CALL INVAL (WR_P,0.D0)
      CALL INVAL (WR_Q,0.D0)
      CALL INVAL (WR_R,0.D0)
      CALL INVAL (WR_S,0.D0)
      CALL INVAL (WR_U,0.D0)
      CALL INVAL (WR_V,0.D0)
      K_ = 0.0d0
C WR  END OF INITIALIZATION
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      WRITE(*,*) 'DELT = ', DELT
      WRITE(*,*) 'LINFO = ', LINFO
            
C WR START OF ESTABLISHING THE COEFFICIENT-MATRIX

!       OPEN(87,FILE='cds.out')
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
            
            SRCE = 0.D0
            SRCE2 = 0.D0
            SRCE3 = 0.D0
            
            PSI_T = 0.D0
            PSI_B = 0.D0
            PSI_E = 0.D0
            PSI_W = 0.D0
            PSI_N = 0.D0
            PSI_S = 0.D0
                  
C *********************************************************************
C   die Indize fuer die Seiten des CV verteilen sich wie folgt (siehe transf3d.f):
C   1 = E, 2 = N, 3 = T, 4 = W, 5 = S, 6 = B
C
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!       DICHTE(I,J,K) ;  RHOF ;  DVISC          
!   HYCON WIRD IN koppx.f90 berechnet:
!       HYCON(I,J,K)=SIGN((PERM(I,J,K)*drho*GRAV/DVISC),HYCON(i,j,k))
! ALSO IST rho * k / mu = HYCON(I,J,K)/grav !!!
! *********************************************************************
      IF(I.LT.I0)THEN
      IP2 = I+1
      JP2 = J
      KP2 = K
      FACA_e = HMHYCON(I,J,K,IP2,JP2,KP2,1)
      PSI_E = NOBUOY(I,J,K,IP2,JP2,KP2,1)
      ELSE
      FACA_e = DABS(HYCON(I,J,K))*ANISOI(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(I.GT.1)THEN
      IP2 = I-1
      JP2 = J
      KP2 = K      
      FACA_w = HMHYCON(I,J,K,IP2,JP2,KP2,4)
      PSI_W = NOBUOY(I,J,K,IP2,JP2,KP2,4)
      ELSE
      FACA_w = DABS(HYCON(I,J,K))*ANISOI(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(J.LT.J0)THEN
      IP2 = I
      JP2 = J+1
      KP2 = K
      FACA_n = HMHYCON(I,J,K,IP2,JP2,KP2,2)
      PSI_N = NOBUOY(I,J,K,IP2,JP2,KP2,2)
      ELSE
      FACA_n = DABS(HYCON(I,J,K))*ANISOJ(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(J.GT.1)THEN
      IP2 = I
      JP2 = J-1
      KP2 = K
      FACA_s = HMHYCON(I,J,K,IP2,JP2,KP2,5)
      PSI_S = NOBUOY(I,J,K,IP2,JP2,KP2,5)
      ELSE
      FACA_s = DABS(HYCON(I,J,K))*ANISOJ(I,J,K)
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(K.LT.K0)THEN
      IP2 = I
      JP2 = J
      KP2 = K+1
      FACA_t = HMHYCON(I,J,K,IP2,JP2,KP2,3)
      PSI_T = NOBUOY(I,J,K,IP2,JP2,KP2,3)
      ELSE
      FACA_t = DABS(HYCON(I,J,K))
      ENDIF
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      IF(K.GT.1)THEN
      IP2 = I
      JP2 = J
      KP2 = K-1
      FACA_b = HMHYCON(I,J,K,IP2,JP2,KP2,6)
      PSI_B = NOBUOY(I,J,K,IP2,JP2,KP2,6)
      ELSE
      FACA_b = DABS(HYCON(I,J,K))
      ENDIF
C *********************************************************************
      beta_e = FACA_e/VE(I,J,K)
      beta_w = FACA_w/VW(I,J,K)
      beta_n = FACA_n/VN(I,J,K)
      beta_s = FACA_s/VS(I,J,K)
      beta_t = FACA_t/VT(I,J,K)
      beta_b = FACA_b/VB(I,J,K)
C *********************************************************************
C     FUER ANALYTISCHE LOESUNG DOMENICO & PALSCHIAUSKAS (DP VERIFICATION)
      IF(DPVERIF)THEN
      PSI_T = 0.D0
      PSI_B = 0.D0
      ENDIF
      
C     2D-CASE, NO-NORTH-SOUTH (Y-) DIRECTION      
      IF(TEST2D.EQ.3)THEN
      PSI_T = 0.D0
      PSI_B = 0.D0
      ENDIF

      IF(TEST2D.EQ.3)THEN
      PSI_N = 0.D0
      PSI_S = 0.D0
      ENDIF

C **********************************************************************
C   1 = E, 2 = N, 3 = T, 4 = W, 5 = S, 6 = B

      IF (K.LT.K0)
     + SRCE3=SRCE3+PSI_T *BS33(I,J,K,3) * VT(I,J,K)
      IF (K.GT.1)        
     + SRCE3=SRCE3-PSI_B *BS33(I,J,K,6) * VB(I,J,K)

      SRCE=SRCE+
     +VT(I,J,K)*
     +(PSI_T*BS31(I,J,K,3)+PSI_T*BS32(I,J,K,3)+PSI_T*BS33(I,J,K,3))-
     +VB(I,J,K)*
     +(PSI_B*BS31(I,J,K,6)+PSI_B*BS32(I,J,K,6)+PSI_B*BS33(I,J,K,6))

      
C     EAST-FACE ne-se
      D_nese=(D_n(I,J,K)  -D_s(I,J,K))  *(1.D0-FE_CDS(I,J,K,1))+
     &       (D_n(I+1,J,K)-D_s(I+1,J,K))*      FE_CDS(I,J,K,1)
C     EAST-FACE te-be
      D_tebe=(D_t(I,J,K)  -D_b(I,J,K))  *(1.D0-FE_CDS(I,J,K,1))+
     &       (D_t(I+1,J,K)-D_b(I+1,J,K))*      FE_CDS(I,J,K,1)
C     WEST-FACE nw-sw
      D_nwsw=(D_n(I,J,K)  -D_s(I,J,K))  *(1.D0-FW_CDS(I,J,K,1))+
     &       (D_n(I-1,J,K)-D_s(I-1,J,K))*      FW_CDS(I,J,K,1)
C     WEST-FACE tw-bw
      D_twbw=(D_t(I,J,K)  -D_b(I,J,K))  *(1.D0-FW_CDS(I,J,K,1))+
     &       (D_t(I-1,J,K)-D_b(I-1,J,K))*      FW_CDS(I,J,K,1)
C     NORTH-FACE ne-nw
      D_nenw=(D_e(I,J,K)  -D_w(I,J,K))  *(1.D0-FN_CDS(I,J,K,1))+
     &       (D_e(I,J+1,K)-D_w(I,J+1,K))*      FN_CDS(I,J,K,1)
C     NORTH-FACE tn-bn
      D_tnbn=(D_t(I,J,K)  -D_b(I,J,K))  *(1.D0-FN_CDS(I,J,K,1))+
     &       (D_t(I,J+1,K)-D_b(I,J+1,K))*      FN_CDS(I,J,K,1)
C     SOUTH-FACE se-sw
      D_sesw=(D_e(I,J,K)  -D_w(I,J,K))  *(1.D0-FS_CDS(I,J,K,1))+
     &       (D_e(I,J-1,K)-D_w(I,J-1,K))*      FS_CDS(I,J,K,1)
C     SOUTH-FACE ts-bs
      D_tsbs=(D_t(I,J,K)  -D_b(I,J,K))  *(1.D0-FS_CDS(I,J,K,1))+
     &       (D_t(I,J-1,K)-D_b(I,J-1,K))*      FS_CDS(I,J,K,1)
C     TOP-FACE tn-ts
      D_tnts=(D_n(I,J,K)  -D_s(I,J,K))  *(1.D0-FT_CDS(I,J,K,1))+
     &       (D_n(I,J,K+1)-D_s(I,J,K+1))*      FT_CDS(I,J,K,1)
C     TOP-FACE te-tw
      D_tetw=(D_e(I,J,K)  -D_w(I,J,K))  *(1.D0-FT_CDS(I,J,K,1))+
     &       (D_e(I,J,K+1)-D_w(I,J,K+1))*      FT_CDS(I,J,K,1)
C     BASE-FACE bn-bs
      D_bnbs=(D_n(I,J,K)  -D_s(I,J,K))  *(1.D0-FB_CDS(I,J,K,1))+
     &       (D_n(I,J,K-1)-D_s(I,J,K-1))*      FB_CDS(I,J,K,1)
C     BASE-FACE be-bw
      D_bebw=(D_e(I,J,K)  -D_w(I,J,K))  *(1.D0-FB_CDS(I,J,K,1))+
     &       (D_e(I,J,K-1)-D_w(I,J,K-1))*      FB_CDS(I,J,K,1)

      DD1 =VE(I,J,K)*FACA_e*(BS13(I,J,K,1)*D_tebe)   ! E
      DD2 =VW(I,J,K)*FACA_w*(BS13(I,J,K,4)*D_twbw)   ! W
      DD3 =VN(I,J,K)*FACA_n*(BS23(I,J,K,2)*D_tnbn)   ! N
      DD4 =VS(I,J,K)*FACA_s*(BS23(I,J,K,5)*D_tsbs)   ! S
      DD5 =VT(I,J,K)*FACA_t*(BS32(I,J,K,3)*D_tnts+
     +                       BS31(I,J,K,3)*D_tetw)   ! T
      DD6 =VB(I,J,K)*FACA_b*(BS32(I,J,K,6)*D_bnbs+
     +                       BS31(I,J,K,6)*D_bebw)   ! B
      
      SRCE2 = SRCE2 + DD1-DD2 + DD3-DD4 + DD5-DD6
            
C *********************************************************************
C   die Indize fuer die Seiten des CV verteilen sich wie folgt (siehe transf3d.f):
C   1 = E, 2 = N, 3 = T, 4 = W, 5 = S, 6 = B

! 001   P_ne = (P_nP - P_sP) * (1.D0 - FP1) + (P_nE - P_sE) * FP1
C
C     P_n, and so on, has been calculated in cds3_P().
C     THE CROSS DIFFERENCES (OR DERIVATIVES) ARE NO LONGER CALCULATED 
C     DIRECTLY BUT FOLLOWING PERIC (1985).
C
C     EAST-FACE ne-se
001   P_nese=(P_n(I,J,K)  -P_s(I,J,K))  *(1.D0-FE_CDS(I,J,K,1))+
     &       (P_n(I+1,J,K)-P_s(I+1,J,K))*      FE_CDS(I,J,K,1)
C     EAST-FACE te-be
002   P_tebe=(P_t(I,J,K)  -P_b(I,J,K))  *(1.D0-FE_CDS(I,J,K,1))+
     &       (P_t(I+1,J,K)-P_b(I+1,J,K))*      FE_CDS(I,J,K,1)
C     WEST-FACE nw-sw
003   P_nwsw=(P_n(I,J,K)  -P_s(I,J,K))  *(1.D0-FW_CDS(I,J,K,1))+
     &       (P_n(I-1,J,K)-P_s(I-1,J,K))*      FW_CDS(I,J,K,1)
C     WEST-FACE tw-bw
004   P_twbw=(P_t(I,J,K)  -P_b(I,J,K))  *(1.D0-FW_CDS(I,J,K,1))+
     &       (P_t(I-1,J,K)-P_b(I-1,J,K))*      FW_CDS(I,J,K,1)
C     NORTH-FACE ne-nw
005   P_nenw=(P_e(I,J,K)  -P_w(I,J,K))  *(1.D0-FN_CDS(I,J,K,1))+
     &       (P_e(I,J+1,K)-P_w(I,J+1,K))*      FN_CDS(I,J,K,1)
C     NORTH-FACE tn-bn
006   P_tnbn=(P_t(I,J,K)  -P_b(I,J,K))  *(1.D0-FN_CDS(I,J,K,1))+
     &       (P_t(I,J+1,K)-P_b(I,J+1,K))*      FN_CDS(I,J,K,1)
C     SOUTH-FACE se-sw
007   P_sesw=(P_e(I,J,K)  -P_w(I,J,K))  *(1.D0-FS_CDS(I,J,K,1))+
     &       (P_e(I,J-1,K)-P_w(I,J-1,K))*      FS_CDS(I,J,K,1)
C     SOUTH-FACE ts-bs
008   P_tsbs=(P_t(I,J,K)  -P_b(I,J,K))  *(1.D0-FS_CDS(I,J,K,1))+
     &       (P_t(I,J-1,K)-P_b(I,J-1,K))*      FS_CDS(I,J,K,1)
C     TOP-FACE tn-ts
009   P_tnts=(P_n(I,J,K)  -P_s(I,J,K))  *(1.D0-FT_CDS(I,J,K,1))+
     &       (P_n(I,J,K+1)-P_s(I,J,K+1))*      FT_CDS(I,J,K,1)
C     TOP-FACE te-tw
010   P_tetw=(P_e(I,J,K)  -P_w(I,J,K))  *(1.D0-FT_CDS(I,J,K,1))+
     &       (P_e(I,J,K+1)-P_w(I,J,K+1))*      FT_CDS(I,J,K,1)
C     BASE-FACE bn-bs
011   P_bnbs=(P_n(I,J,K)  -P_s(I,J,K))  *(1.D0-FB_CDS(I,J,K,1))+
     &       (P_n(I,J,K-1)-P_s(I,J,K-1))*      FB_CDS(I,J,K,1)
C     BASE-FACE be-bw
012   P_bebw=(P_e(I,J,K)  -P_w(I,J,K))  *(1.D0-FB_CDS(I,J,K,1))+
     &       (P_e(I,J,K-1)-P_w(I,J,K-1))*      FB_CDS(I,J,K,1)
c ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      DP1 = DC12(I,J,K,1)*P_nese + DC13(I,J,K,1)*P_tebe   ! E
      DP2 = DC12(I,J,K,4)*P_nwsw + DC13(I,J,K,4)*P_twbw   ! W
      DP3 = DC21(I,J,K,2)*P_nenw + DC23(I,J,K,2)*P_tnbn   ! N
      DP4 = DC21(I,J,K,5)*P_sesw + DC23(I,J,K,5)*P_tsbs   ! S
      DP5 = DC32(I,J,K,3)*P_tnts + DC31(I,J,K,3)*P_tetw   ! T
      DP6 = DC32(I,J,K,6)*P_bnbs + DC31(I,J,K,6)*P_bebw   ! B            
      
      WR_P(I,J,K) = beta_e * DP1 ! E
      WR_Q(I,J,K) = beta_w * DP2 ! W
      WR_R(I,J,K) = beta_n * DP3 ! N
      WR_S(I,J,K) = beta_s * DP4 ! S
      WR_U(I,J,K) = beta_t * DP5 ! T
      WR_V(I,J,K) = beta_b * DP6 ! B

C **********************************************************************

      A(I,J,K) = DC33(I,J,K,6) * beta_b
      B(I,J,K) = DC22(I,J,K,5) * beta_s
      C(I,J,K) = DC11(I,J,K,4) * beta_w
      E(I,J,K) = DC11(I,J,K,1) * beta_e
      F(I,J,K) = DC22(I,J,K,2) * beta_n
      G(I,J,K) = DC33(I,J,K,3) * beta_t
      
      IF(I.EQ.1)THEN
      C(I,J,K) = 0.D0
      WR_Q(I,J,K) = 0.D0
      ENDIF
      IF(J.EQ.1)THEN
      B(I,J,K) = 0.D0
      WR_S(I,J,K) = 0.D0
      ENDIF
      IF(K.EQ.1)THEN
      A(I,J,K) = 0.D0
      WR_V(I,J,K) = 0.D0
      ENDIF
      IF(I.EQ.I0)THEN
      E(I,J,K) = 0.D0
      WR_P(I,J,K) = 0.D0
      ENDIF
      IF(J.EQ.J0)THEN
      F(I,J,K) = 0.D0
      WR_R(I,J,K) = 0.D0
      ENDIF
      IF(K.EQ.K0)THEN
      G(I,J,K) = 0.D0
      WR_U(I,J,K) = 0.D0
      ENDIF
      
      D(I,J,K) = -1.D0*
     & (A(I,J,K)+B(I,J,K)+C(I,J,K)+E(I,J,K)+F(I,J,K)+G(I,J,K))
      
      WR_L(I,J,K) = DABS(S(I,J,K)) * VP(I,J,K)/delt
      
      D(I,J,K) = D(I,J,K) - WR_L(I,J,K) 

C *********************************************************************              
C  WR, 051021
C      IF(HF(I,J,K).NE.0.D0) WRITE(*,*) 'HF! = ',HF(I,J,K),I,J,K

      W(I,J,K) =(-1.D0*WR_L(I,J,K)*PHI(I,J,K))-(HF(I,J,K)*VP(I,J,K))
     +  -SRCE/VP(I,J,K) - SRCE2/VP(I,J,K)
caw
        if (mpot.eq.0) W(I,J,K) = W(I,J,K)-
     &   (WR_P(I,J,K)-WR_Q(I,J,K)+
     &    WR_R(I,J,K)-WR_S(I,J,K)+
     &    WR_U(I,J,K)-WR_V(I,J,K))

C - - FUER INAKTIVE ODER KONSTANT-PHI KNOTEN  - - - - - - - - - -
C - - (INCL. DIRICHLET RANDBEDINGUNGEN) WIRD D GLEICH NULL GESETZT.  - -
C - - (QUELLEN/SENKEN AUF RANDKNOTEN SIND JEDOCH MOEGLICH) - - - - - - -
C ***************** DIRICHLET BORDER CONDITION ************************
      IF(HYCON(I,J,K).LE.0.D0.OR.S(I,J,K).LT.0.D0.OR.
     &FLOW_DBC(I,J,K).LT.0)THEN
      D(I,J,K) = 0.D0 
      W(I,J,K) = PHI(I,J,K)
C WR: 070305      
      ELSEIF(K.EQ.K0.AND.TOPF.EQ.'HEAD'.AND.
     +  HYCON(I,J,K).GT.0.D0.AND.FLOW_DBC(I,J,K).GT.0.AND.
     +  S(I,J,K).GT.0.D0)THEN
C      WRITE(*,*) 'SPECIAL BC!'     
          D(I,J,K) = 0.D0 
C linear interpolation between (head or phi) p_T(I,J,K) and p_T(I,J,K-1)
C dxx1 = distance p(k)   to CV-Center
C dxx2 = distance p(k-1) to CV-Center
        dxx1 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   SMALLT(I,J,K,1),SMALLT(I,J,K,2),SMALLT(I,J,K,3))
        dxx2 = CALCED(
     +   CENTER(I,J,K,1),CENTER(I,J,K,2),CENTER(I,J,K,3),
     +   SMALLT(I,J,K-1,1),SMALLT(I,J,K-1,2),SMALLT(I,J,K-1,3))
        W(I,J,K) = CALCVA(p_T(I,J,K),p_T(I,J,K-1),dxx1,dxx2)      
      ENDIF
C *********************************************************************

      IF(LINFO.GE.2)THEN
      MEANND =    DABS(A(I,J,K))+DABS(B(I,J,K))+DABS(C(I,J,K))+
     +            DABS(E(I,J,K))+DABS(F(I,J,K))+DABS(G(I,J,K))
      MEANCD =    DABS(WR_P(I,J,K))+DABS(WR_Q(I,J,K))+DABS(WR_R(I,J,K))+
     +            DABS(WR_S(I,J,K))+DABS(WR_U(I,J,K))+DABS(WR_V(I,J,K))
      DRATIO = MEANCD/MEANND
      MINDR = MIN(DRATIO,MINDR)
      MAXDR = MAX(DRATIO,MAXDR)
      ENDIF

      IF(DBG_WR.AND.KT.EQ.1)THEN
C      IF(KT.EQ.1)THEN
      WRITE(93,*) I,J,K
      WRITE(93,1002)
     + A(I,J,K),B(I,J,K),C(I,J,K),D(I,J,K),
     + E(I,J,K),F(I,J,K),G(I,J,K),W(I,J,K)
      WRITE(93,1001)
     + VB(I,J,K),VS(I,J,K),VW(I,J,K),
     + VE(I,J,K),VN(I,J,K),VT(I,J,K),VP(I,J,K)
      WRITE(93,1003)
     + DC33(I,J,K,6),DC22(I,J,K,5),DC11(I,J,K,4),
     + DC11(I,J,K,1),DC22(I,J,K,2),DC33(I,J,K,3)
      WRITE(93,*)
     + (DC33(I,J,K,6)+DC22(I,J,K,5)+DC11(I,J,K,4)-
     + DC11(I,J,K,1)-DC22(I,J,K,2)-DC33(I,J,K,3))
      WRITE(93,1012)
     + DC12(I,J,K,1),DC13(I,J,K,1),
     + DC12(I,J,K,4),DC13(I,J,K,4),
     + DC21(I,J,K,2),DC23(I,J,K,2),
     + DC21(I,J,K,5),DC23(I,J,K,5),
     + DC32(I,J,K,3),DC31(I,J,K,3),
     + DC32(I,J,K,6),DC31(I,J,K,6)     
      WRITE(93,1004) 
     & W(I,J,K),HF(I,J,K),WR_L(I,J,K),PHI(I,J,K)
      WRITE(93,1003)
     & WR_P(I,J,K),WR_Q(I,J,K),WR_R(I,J,K),WR_S(I,J,K),
     & WR_U(I,J,K),WR_V(I,J,K)  
      WRITE(93,*) PSI_T,PSI_B
      WRITE(93,*) 
     & (PSI_T - PSI_B)
      WRITE(93,1003) 
     &GRAVB(I,J,K),GRAVT(I,J,K),GRAVS(I,J,K),
     &GRAVE(I,J,K),GRAVW(I,J,K),GRAVN(I,J,K)
      WRITE(93,*) DICHTE(I,J,K),PRES(I,J,K)
      WRITE(93,*) HYCON(I,J,K)
      WRITE(93,*) BS33(I,J,K,3)/VT(I,J,K), DC33(I,J,K,3)/VT(I,J,K)
      WRITE(93,*)
1001  FORMAT(7(E12.4,1X))
1002  FORMAT(8(E12.4,1X))
1003  FORMAT(6(E12.4,1X))
1004  FORMAT(4(E12.4,1X))
1012  FORMAT(12(E16.8,1X))
      ENDIF
            ENDDO
         ENDDO
      ENDDO
      
      IF(DBG_WR)THEN
      CLOSE(93)
      ENDIF

      WRITE(*,*) 'SRCE = ', SRCE      
      WRITE(*,*) 'SRCE2 = ', SRCE2
      WRITE(*,*) 'SRCE3 = ', SRCE3
      
      IF(LINFO.GE.2)THEN
      WRITE(*,*) '==========================================='
      WRITE(*,*) 'NOFCOEF'
      WRITE(*,*) 'RATIO CROSS / NORMAL DERIVATIVES:'
      WRITE(*,*) 'MIN = ',MINDR
      WRITE(*,*) 'MAX = ',MAXDR
      WRITE(*,*) '==========================================='      
      ENDIF
      
      RETURN
      END
