      subroutine write_vtk
c-----------------------------------------------------------------------      
c last change:  vr   march 21,  2004 (year ?, WR)
c last change:  wr   april 25,  2005
c
c writes data in vtk-format  
c see:         http://mayavi.sourceforge.net
c              http://www.vtk.org/pdf/file-formats.pdf
c-----------------------------------------------------------------------      
c
      USE FELDER
      USE NO
      
      implicit none
      include 'genrl.inc'
      include 'genrlc.inc'
      include 'salz.inc'

      double precision dx,dy,dz,fyear,fday,ftime
      integer i1,i2,i3,i4,lblank,POS
      character filename*80,number*8
c
      INTEGER II2,JJ2,KK2,BBB,II,
     +DIR_1,DIR_2,DIR_3,DIR_4,DIR_5,DIR_6,DIR_7,DIR_8


! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      KK2 = 1        
      DO K=1,K0
      KK2 = KK2+1
         JJ2 = 1
         DO J=1,J0
         JJ2 = JJ2+1
            II2 = 1
            DO I=1,I0
            II2 = II2+1                        
            DIR_1 = 1            
            DIR_2 = 2
            DIR_3 = 3
            DIR_4 = 4
            DIR_5 = 5
            DIR_6 = 6
            DIR_7 = 7
            DIR_8 = 8
! 1: SWT --------------------------------------------------------------
            XXVTC(II2-1,JJ2-1,KK2) = XXI(I,J,K,DIR_1)
            YYVTC(II2-1,JJ2-1,KK2) = YYI(I,J,K,DIR_1)
            ZZVTC(II2-1,JJ2-1,KK2) = ZZI(I,J,K,DIR_1) 
! 2: SET --------------------------------------------------------------
            XXVTC(II2,JJ2-1,KK2) = XXI(I,J,K,DIR_2)
            YYVTC(II2,JJ2-1,KK2) = YYI(I,J,K,DIR_2)
            ZZVTC(II2,JJ2-1,KK2) = ZZI(I,J,K,DIR_2)            
! 3: NET --------------------------------------------------------------
            XXVTC(II2,JJ2,KK2) = XXI(I,J,K,DIR_3)
            YYVTC(II2,JJ2,KK2) = YYI(I,J,K,DIR_3)
            ZZVTC(II2,JJ2,KK2) = ZZI(I,J,K,DIR_3)            
! 4 NWT ---------------------------------------------------------------
            XXVTC(II2-1,JJ2,KK2) = XXI(I,J,K,DIR_4)
            YYVTC(II2-1,JJ2,KK2) = YYI(I,J,K,DIR_4)
            ZZVTC(II2-1,JJ2,KK2) = ZZI(I,J,K,DIR_4)
! 5: SWB --------------------------------------------------------------
            XXVTC(II2-1,JJ2-1,KK2-1) = XXI(I,J,K,DIR_5)
            YYVTC(II2-1,JJ2-1,KK2-1) = YYI(I,J,K,DIR_5)
            ZZVTC(II2-1,JJ2-1,KK2-1) = ZZI(I,J,K,DIR_5)
! 6: SEB --------------------------------------------------------------
            XXVTC(II2,JJ2-1,KK2-1) = XXI(I,J,K,DIR_6)
            YYVTC(II2,JJ2-1,KK2-1) = YYI(I,J,K,DIR_6)
            ZZVTC(II2,JJ2-1,KK2-1) = ZZI(I,J,K,DIR_6)            
! 7: NEB --------------------------------------------------------------
            XXVTC(II2,JJ2,KK2-1) = XXI(I,J,K,DIR_7)
            YYVTC(II2,JJ2,KK2-1) = YYI(I,J,K,DIR_7)
            ZZVTC(II2,JJ2,KK2-1) = ZZI(I,J,K,DIR_7)
! 8: NWB --------------------------------------------------------------
            XXVTC(II2-1,JJ2,KK2-1) = XXI(I,J,K,DIR_8)
            YYVTC(II2-1,JJ2,KK2-1) = YYI(I,J,K,DIR_8)
            ZZVTC(II2-1,JJ2,KK2-1) = ZZI(I,J,K,DIR_8)           
            ENDDO
         ENDDO
      ENDDO      
C *********************************************************************      
!       BBB = 1
!       DO K=1,K0+1
!          DO J=1,J0+1
!             DO I=1,I0+1
!             BNR(I,J,K) = BBB
!             BBB = BBB + 1
!             WRITE(77,'(6G23.15)')
!      +      XXVTC(I,J,K),YYVTC(I,J,K),ZZVTC(I,J,K),TTVTC(I,J,K),
!      +TTVTC(I,J,K)-(((SMALLT(1,1,K0,3)-ZZVTC(I,J,K))*0.03D0)+283.15D0),
!      +MATXYZ(I,J,K)
!             ENDDO
!          ENDDO
!       ENDDO      
            
!       DO K=1,K0
!          DO J=1,J0
!             DO I=1,I0
!       WRITE(77,'(8I9)')     
!      + BNR(I,J,K),  BNR(I+1,J,K),  BNR(I+1,J+1,K),  BNR(I,J+1,K),
!      + BNR(I,J,K+1),BNR(I+1,J,K+1),BNR(I+1,J+1,K+1),BNR(I,J+1,K+1)
!             ENDDO            
!          ENDDO
!       ENDDO
    ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++     

c velocities in m/a
      fyear=31536000.0d0
c velocities in m/d
      fday=86400.0d0
      ftime=fday
      
      POS=INDEX(PROJ,' ')-1
      filename=
     &  './PERIOD'//ZEI(1:LENGTH)//'/'//PROJ(1:POS)//'.vtk'
c
      open (76,file=filename,status='unknown',blank='null')
c
      write(*,'(3A)') '  [W] : VTK to ',
     *                  filename(1:lblank(filename)),' ...'
      
c HEADER
      write (76,'(a/a/a/a/a,3i5)') 
     &  '# vtk DataFile Version 2.0',
     &  PROJ(1:POS)//' '//'  PERIOD'//ZEI(1:LENGTH),
     &  'ASCII',
     &  'DATASET UNSTRUCTURED_GRID'
!      &  ,'DIMENSIONS  ',i0,j0,k0
   
      write (76,'(a,i5,a)') 'POINTS  ',(i0+1)*(j0+1)*(k0+1),' float'
      
      BBB = 0
      DO K = 1, K0+1
      DO J = 1, J0+1
      DO I = 1, I0+1
            BNR(I,J,K) = BBB
            BBB = BBB + 1      
      WRITE (76,'(3(E12.4,1X))') 
     +XXVTC(I,J,K),YYVTC(I,J,K),ZZVTC(I,J,K)
      ENDDO
      ENDDO
      ENDDO

      write (76,'(a,i5,1X,I7)') 'CELLS  ',(i0*j0*k0),
     +                         (i0*j0*k0*9)
      DO K=1,K0
         DO J=1,J0
            DO I=1,I0
      WRITE(76,'(A2,1X,8(I9))') '8 ',
     +BNR(I,J,K)  ,BNR(I+1,J,K),  BNR(I+1,J+1,K),  BNR(I,J+1,K),
     +BNR(I,J,K+1),BNR(I+1,J,K+1),BNR(I+1,J+1,K+1),BNR(I,J+1,K+1)
            ENDDO            
         ENDDO
      ENDDO

      write (76,'(a,i5,a)') 'CELL_TYPES  ',(i0)*(j0)*(k0),''
      DO II = 1, (i0)*(j0)*(k0)
      WRITE(76,'(A2)') '12'
      ENDDO

c      
       write (76,'(/a,i8)') 'CELL_DATA',i0*j0*k0
c 
       write (76,'(a)') 'SCALARS TEMP float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((TEMP(i,j,k),i=1,i0),j=1,j0),k=1,k0)
c
       write (76,'(a)')  'SCALARS PHI float 1'
       write (76,'(a)')  'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((PHI(i,j,k),i=1,i0),j=1,j0),k=1,k0)
c
       write (76,'(a)') 'SCALARS kx float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')
     &     (((abs(PERM(i,j,k)*ANISOI(I,J,K)),i=1,i0),j=1,j0),k=1,k0)
       write (76,'(a)') 'SCALARS ky float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')
     &     (((abs(PERM(i,j,k)*ANISOJ(I,J,K)),i=1,i0),j=1,j0),k=1,k0)
       write (76,'(a)') 'SCALARS PERM float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')
     &    (((abs(PERM(i,j,k)),i=1,i0),j=1,j0),k=1,k0)
c
       write (76,'(a)') 'SCALARS lx float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((WLX(i,j,k),i=1,i0),j=1,j0),k=1,k0)
       write (76,'(a)')  'SCALARS ly float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((WLY(i,j,k),i=1,i0),j=1,j0),k=1,k0)
       write (76,'(a)') 'SCALARS lz float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((WLZ(i,j,k),i=1,i0),j=1,j0),k=1,k0)
c
       write (76,'(a)')  'SCALARS por float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((abs(POR(i,j,k)),i=1,i0),j=1,j0),k=1,k0)
       write (76,'(a)') 'SCALARS h float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((H(i,j,k),i=1,i0),j=1,j0),k=1,k0)
c
       write (76,'(a)')  'SCALARS por float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((abs(POR(i,j,k)),i=1,i0),j=1,j0),k=1,k0)
       write (76,'(a)') 'SCALARS h float 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(10e12.4)')(((H(i,j,k),i=1,i0),j=1,j0),k=1,k0)
c
       write (76,'(a)') 'VECTORS v float'
       write(76,'(3g12.4)')
     &  (((VX_E(i,j,k)*ftime,VY_N(i,j,k)*ftime,VZ_T(i,j,k)*ftime, 
     &   i=1,i0),j=1,j0),k=1,k0)
     
!         write (76,'(a)') 'SCALARS geology int 1'
!        write (76,'(a)') 'LOOKUP_TABLE default'
!        write(76,'(25i4)')(((GEOLOGY(i,j,k),i=1,i0),j=1,j0),k=1,k0)
       
       write (76,'(a)') 'SCALARS geology int 1'
       write (76,'(a)') 'LOOKUP_TABLE default'
       write(76,'(25i4)')(((INT(MATXYZ(i,j,k)),i=1,i0),j=1,j0),k=1,k0)
       
       if(KEY(3:3).ne.'-') then
          write (76,'(a)')  'SCALARS redox float 1'
          write (76,'(a)') 'LOOKUP_TABLE default'
          write(76,'(10e12.4)')(((redox(i,j,k),i=1,i0),j=1,j0),k=1,k0)
           
           do i3=1,ANZSUBS
              write (number,'(i2)') 
             call chln(number,i1,i2)
             write (76,'(a,a,a)') 'SCALARS sub',number(i1:i2),' float 1'
             write (76,'(a)')     'LOOKUP_TABLE default'
             write(76,'(10e12.4)')
     &          (((CONCar(i3,j,j,k),i=1,i0),j=1,j0),k=1,k0)
          end do
           do i3=1,ANZMINS
              write (number,'(i2)') 
             call chln(number,i1,i2)
             write (76,'(a,a,a)') 'SCALARS min',number(i1:i2),' float 1'
             write (76,'(a)')     'LOOKUP_TABLE default'
             write(76,'(10e12.4)')
     &          (((CONCm(i3,j,j,k),i=1,i0),j=1,j0),k=1,k0)
          end do

      end if
c
      close(76)
c
      end
